// The "freEvolve System" is a platform supporting the reconfiguration of 
// component-based applications'
// Copyright (C) 1999  Ralph Hinken and Dr. Oliver Stiemerling
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Version: 1.0
// Date:    09.10.2001
//
// History:
//

package org.freevolve.client;

import org.freevolve.server.*;
import java.rmi.*;
import java.awt.*;
import java.io.*;
import java.util.*;
import java.lang.reflect.*;
import java.net.*;
import java.awt.event.*;

public class AwtClient extends Frame implements I_Info, EvolveClient {
  java.awt.List      DCATList = null;
  TextArea  infoArea = null;
  IR_Server   server = null;
  String        user = null;
  Panel     CATpanel = null;
  Label          pos = null;
  Point            p = null;
  Hashtable    proxy = null;
  Hashtable distComps = null;
  Hashtable applications = null;
  org.freevolve.server.Proxy currentProxy = null;
  IR_DistComponent currentDistComp = null;
  String currentDCATName = null;
  int selected      = 0;
  AwtClient        self = null;
  String ID          = "";
  static final Color EvolveBlue = new Color (225,225,255);
  URLClassLoader ucl = null;

  
  
  public void ini(String serverName, String user, String ID, URLClassLoader ul) {
     try {
      ucl = ul;
      self = this;
      this.server = (IR_Server) Naming.lookup("rmi://" + serverName + "/EvolveServer");
      this.user = user;
      this.ID = this.server.getID(user, ID);
      infoArea.setText("Benutzer " + user + ":" + this.ID +"\n");    
      this.setTitle("Client EVOLVE - PLATTFORM fr " + user +":"+ID+ " an EvolveServer auf " + serverName);
      System.out.println("Angebunden an EvolveServer als " + this.user + ":"+this.ID);
      this.applications = this.server.getApplications(user);
      
      if (this.applications ==  null) {System.out.println("Der Server gibt mir keine Anwendungsliste."); System.exit(0);}
      System.out.println("DCAT Dateiliste fuer " + this.user +" vom Server erhalten.");

      for(Enumeration e = applications.keys(); e.hasMoreElements(); ) {
	      this.DCATList.add((String) e.nextElement());
      }
      this.DCATList.add("");
      this.DCATList.add(">Anwendung beenden");
      this.DCATList.add(">Cache lschen");
      this.DCATList.add(">Zeige DCAT, CAT, RBD");
      this.pack();
      this.show();
    } catch (Exception e) {
      System.out.println("AwtClient: " + e);
    }
  }

  public AwtClient() {
    this.setLayout(new BorderLayout());
    //this.setTitle("Client EVOLVE - PLATTFORM fr " + user + " auf " + host);
    proxy     = new Hashtable();   
    distComps = new Hashtable();
    infoArea  = new TextArea();
    infoArea.setEditable(false);
    Button quitButton = new Button();
    quitButton.setLabel("Beenden");
    quitButton.setFont(new Font("DialogInput", Font.PLAIN, 16));
    quitButton.setBackground(new Color (220,220,255));
    quitButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
         quitButton_actionPerformed(e);
      }
    });
    
    Panel panelL = new Panel();
    panelL.setLayout(new BorderLayout());
    Panel panelR = new Panel();
    panelR.setLayout(new BorderLayout());
    CATpanel = new Panel();
    CATpanel.setLayout(null);
    CATpanel.setBackground(EvolveBlue);
    CATpanel.addMouseMotionListener(mmListener);
    CATpanel.setBounds(0,0,500,500);
    pos = new Label();
    pos.setBounds(0, 480, 60, 20);
    pos.setForeground(new Color (180, 180, 200));
    CATpanel.add(pos);
    DCATList = new java.awt.List(20, true);
    DCATList.setMultipleMode(false);
    DCATList.addItemListener(DCATListListener);
    Label l_top = new Label("Anwendungen: ", Label.CENTER);
    l_top.setFont(new Font("DialogInput", Font.PLAIN, 16));
    l_top.setBackground(new Color (220,220,255));

    this.add  (panelL,     BorderLayout.WEST);
    this.add  (panelR,     BorderLayout.CENTER);
    panelR.add(CATpanel,     BorderLayout.NORTH);
    panelR.add(infoArea,   BorderLayout.CENTER);
    panelL.add(l_top,      BorderLayout.NORTH);
    panelL.add(DCATList,      BorderLayout.CENTER);
    panelL.add(quitButton, BorderLayout.SOUTH);
    System.out.println("AwtClient Konstruktur ende.");
  }

  
  MouseMotionListener mmListener = new MouseMotionListener() {
    public void mouseMoved(MouseEvent e) {
         p = e.getPoint();
         pos.setForeground(new Color (180, 180, 200));
         pos.setText("(" + p.x + "," + p.y +")");
     }
     public void mouseDragged(MouseEvent e) {
         pos.setForeground(new Color(250,100, 100));
         pos.setText("(" + (e.getX()- p.x) + "," + (e.getY() -p.y) +")");
         //
     }
  };

  ItemListener DCATListListener = new ItemListener() {
    public void itemStateChanged(ItemEvent e) {
      String dateiName = ((java.awt.List)e.getItemSelectable()).getSelectedItem();
      if (dateiName.equals(">Anwendung beenden")) {
         selected = DCATList.getSelectedIndex();
         delApplication();
      } else if (dateiName.equals(">Cache lschen")) {
         deleteCache();
         DCATList.select(selected);
      } else if (dateiName.equals(">Zeige DCAT, CAT, RBD")) {
         showDCAT();
         DCATList.select(selected);
      } else if (dateiName.length()>0){
         selected = DCATList.getSelectedIndex();
         DCATList.setEnabled(false);

         getApplication(dateiName);
         setSize(getSize().width+1,getSize().height+1);
         setSize(getSize().width-1,getSize().height-1);
         DCATList.setEnabled(true);
      } else DCATList.select(selected);

    }
  };
 
 private void delApplication() {
     if (currentProxy==null) return;
     try {
         server.removeApplication(user, ID, currentDCATName);
         proxy.remove(currentDCATName);
         distComps.remove(currentDCATName);
     } catch (RemoteException re) {
         message("error", 1, "deleteApplication: " + re.toString());
    }
    currentProxy.hide();
    infoArea.setText("Benutzer " + user + ":" + this.ID +"\n");    
    setSize(getSize().width+1,getSize().height+1);
    setSize(getSize().width-1,getSize().height-1);
    currentDCATName="";
    currentDistComp=null;
    currentProxy=null;
}

  
 private void showDCAT() {
   IR_DistComponent dc  = currentDistComp;
   IR_DistComponent dcs = null;
   IR_Component     c   = null;
   String           CAT = null;
   String          DCAT = null;
   try {
        if (currentDistComp == null) return;
        infoArea.append("Versuche " + currentDCATName + ".DCAT zu erzeugen:\n");
        hr();
        DCAT = dc.writeDistComponent();
        if (DCAT != null) infoArea.append(DCAT);
        br();
        c = dc.getComponent();    	  
        if (c != null) {
           infoArea.append("Versuche  " + c.getTypeName() + ".CAT zu erzeugen:\n");
           hr();
           CAT = c.toText();
           if (CAT != null) infoArea.append(CAT);
           br();
  
           for (Enumeration e2 = dc.getLinkedDistComps().elements(); e2.hasMoreElements();) {
           	  infoArea.append("Verbundene DistComponenten:\n");
              dcs = (IR_DistComponent) e2.nextElement();
              c = dcs.getComponent();
           	  infoArea.append(c.getTypeName() +".CAT : \n");
              hr();
              if (c != null) {
                 CAT = c.toText();
                 if (CAT != null) infoArea.append(CAT);
              }
              br();
           }

          IR_RBD rbd = null;
          for ( Enumeration e2 = dc.getMyRBDs().elements(); e2.hasMoreElements();) {
           	  infoArea.append("Remote Binds :\n");
              rbd = (IR_RBD) e2.nextElement();
              if (rbd != null) {
            	  infoArea.append("Versuche "  + rbd.getName()+".RBD zu erzeugen:\n");
                 hr();
                 CAT = rbd.write();
                 if (CAT != null) infoArea.append(CAT);
              }
              br();
           }
         // infoArea.append("Speicher alles nach d:/.\n");
         // server.saveDistComponent(dc, "d:/");
         // infoArea.append("Melde DCAT wieder ab.\n");
         // server.removeDistComponent(user, dateiName);
         // infoArea.append("********************  O K  **************************\n");
        
               
//    	infoArea.select(0,0);
      }

      } catch (Exception re) {
	         message("error", 1, "AwtClient: " + re);
      }
 }
 
 
 private void getApplication(String dateiName) {
   infoArea.setText("Benutzer " + user + ":" + this.ID +"\n");    
   infoArea.append(dateiName + ":\n");
   IR_DistComponent dc  = null;
   IR_DistComponent dcs = null;
   IR_Component     c   = null;
   String           CAT = null;
   String          DCAT = null;

    if (currentProxy != null) {
        currentProxy.hide();
        setSize(getSize().width+1,getSize().height+1);
        setSize(getSize().width-1,getSize().height-1);
    }
   if (proxy.containsKey(dateiName)) {
      currentProxy = (org.freevolve.server.Proxy) proxy.get(dateiName);
      currentProxy.show();
      currentDistComp = (IR_DistComponent) distComps.get(dateiName);
      currentDCATName = dateiName;
   } else {
      try {
         long start = (new Date()).getTime();         
         dc = server.getNewApplication(user, ID, dateiName);
     	   if (dc!= null) infoArea.append("DistComponente " + server.getDCATName(user, dateiName) + " bekommen.\n");
         else {
           infoArea.append("Keine DistComponente bekommen.\n");
           return;
         }
       	if (dc != null) {
           c = dc.getComponent();
           if (c != null) {
              infoArea.append("Erzeuge Proxy Objekte.\n");
              currentDCATName = dateiName;
              currentProxy = new org.freevolve.server.Proxy(c, self, true);
              currentDistComp = dc;
              proxy.put(dateiName, currentProxy);
              distComps.put(dateiName, currentDistComp);
              dc.setProxy((IR_Proxy) currentProxy);
              dc.bindAll();
              long stop =  (new Date()).getTime();         
              //message("info",1, "In " + (stop-start) + " ms.");
              infoArea.append("In " + (stop-start) + " ms. ("+dateiName+")");
              System.out.println("In " + (stop-start) + " ms. ("+dateiName+")");
           }  else {
              infoArea.append("Keine lokale Komponente bekommen.\n");
              return;
          }
        } // end dc != null
     } catch (Exception re) {
	         message("error", 1, "AwtClient.getApplication: " + re);
     }
   }
}

/** Meldet alle gespeicherten DCATs beim Server ab und entfernt die Proxyobjekte aus dem
    Cache. Dabei wird die aktuelle Anwendung nicht abgemeldet bzw. aus dem Cache entfernt.
*/
private void deleteCache() {
   String name = null;
   for (Enumeration e=distComps.keys();e.hasMoreElements() ; ) {
       name = (String) e.nextElement();
       if (!name.equals(currentDCATName)) {
          try {
              server.removeApplication(user, ID, name);
              message("info", 2, "Lsche " + name + " aus dem cache.");
          } catch (RemoteException re) {
               message("error", 1, "deleteCache: " + re.toString());
          }
       }
   }
   message("info",2,"Fertig.");
   proxy     = new Hashtable();
   distComps = new Hashtable();
   if (currentProxy != null) {
      proxy.put(currentDCATName, currentProxy);
      distComps.put(currentDCATName, currentDistComp);
   }
}


 public void message(String typ, int level, String m) {
    
     infoArea.append(m+"\n");
  }

  void br() { infoArea.append("##################################################\n");}
  void hr() { infoArea.append("__________________________________________________\n");}
  
  void quitButton_actionPerformed(ActionEvent e) {
    delApplication();
    deleteCache();
    try {
      server.goodByeServer(user, ID);
     } catch (Exception re) {
	         message("error", 1, "AwtClient: " + re);
     }
    System.exit(0);
  }
  public URLClassLoader getURLClassLoader(){ return ucl;}
  public Container getPanel() { return CATpanel ;}
  public String getUser() { return user;}
  public String getID() { return ID;}

}

