// The "freEvolve System" is a platform supporting the reconfiguration of 
// component-based applications'
// Copyright (C) 1999  Ralph Hinken and Dr. Oliver Stiemerling
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Version: 1.0
// Date:    09.10.2001
//
// History:
//

package org.freevolve.client;

import org.freevolve.server.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.InternalFrameListener;
import javax.swing.event.InternalFrameEvent;
import java.util.*;
import java.rmi.*;
import java.net.URLClassLoader;

public class ClientFrame extends JFrame implements I_Info, EvolveClient{

   
   //Frame konstruieren
   Hashtable innerWin = new Hashtable();
   ClientInfo currentClient = null;
   JInternalFrame currentIFrame = null;

   BorderLayout borderLayout1 = new BorderLayout();
   JMenuBar menuBar = new JMenuBar();
   JMenu menuFile = new JMenu();
   JMenuItem menuFileNew = new JMenuItem();
   JMenu menuView = new JMenu();
   JMenuItem menuAnsichtDCAT = new JMenuItem();
   JToolBar toolBar = new JToolBar();
   JButton newWin = new JButton();
   JButton closeWin = new JButton();
   JButton EndApp = new JButton();
   JTextArea infoArea = new JTextArea();
   ImageIcon image0;
   ImageIcon image1;
   ImageIcon image2;
   ImageIcon image3;
   ImageIcon image4;
   ImageIcon image5;
   ImageIcon image6;
   JLabel statusBar = new JLabel();
   JPanel mainPanel = new JPanel();
   JButton DelCach = new JButton();
   BorderLayout borderLayout2 = new BorderLayout();
   JMenu An = new JMenu();
   JButton viewDCAT = new JButton();
   JMenu menuHelp = new JMenu();
   JMenuItem menuHelpAbout1 = new JMenuItem();
   JMenuItem menuFilecloseWin = new JMenuItem();
   JMenuItem menuFileExit2 = new JMenuItem();
   JButton anpassen = new JButton();
   JMenuItem menuAppBeend = new JMenuItem();
   JMenuItem menuAppdelCache = new JMenuItem();
   JMenuItem menuViewClear = new JMenuItem();
   Point p = new Point(0,0);
   String status ="";
   int fcount = 1;

    JCheckBox closeBox;
    JCheckBox maxBox;
    JCheckBox iconBox;
    JCheckBox resizeBox;
    JTextField titleField;
    JTextField layerField;
    JButton closeAllButton;
    JButton makeButton;
    JLayeredPane lc;
    int makeCount = 0;
    JInternalFrame maker;

  String   directory = null;
  IR_Server   server = null;
  String serverName = null;
  String        user = null;
  String        ID = "";
  URLClassLoader ucl = null;
  Hashtable applications = null;
   
   public ClientFrame() {
      super();
      enableEvents(AWTEvent.WINDOW_EVENT_MASK);
      System.out.println("ClientFrame Konstruktor ok");
   }

   public void ini(String serverName, String user, String ID, URLClassLoader ul) {
     try {
      ucl = ul;
      this.server = (IR_Server) Naming.lookup("rmi://" + serverName + "/EvolveServer");
      this.user = user;
      this.ID = this.server.getID(user, ID);
      this.setTitle("Client EVOLVE - PLATTFORM fr " + user +":"+ID+ " an EvolveServer auf " + serverName); System.out.println("Angebunden an EvolveServer als " + this.user + ":"+this.ID + " an " + serverName);
      this.applications = this.server.getApplications(user);
      
      if (this.applications ==  null) {System.out.println("Der Server gibt mir keine Anwendungsliste."); System.exit(0);}
      System.out.println("DCAT Dateiliste fuer " + this.user +" vom Server erhalten.");

      
      for(Enumeration e = applications.keys(); e.hasMoreElements(); ) {
	      createNewEntry((String) e.nextElement());
      }
      System.out.println("lese Bilder ein.");
///////////////////////////////////////////////////////////////////////////////////////      
      jbInit();
      System.out.println("ready init ");
      //validate();
      //pack();
      setVisible(true);
    } catch (Exception e) {
      System.out.println("ClientFrame: " + e);
    }
  }

//Initialisierung der Komponente
   
   private void jbInit() throws Exception  {
      image1 = new ImageIcon(getClass().getResource("openwindow.gif"));
      image2 = new ImageIcon(getClass().getResource("closewindow.gif"));
      image3 = new ImageIcon(getClass().getResource("stop.gif"));
      image4 = new ImageIcon(getClass().getResource("clear.gif"));
      image5 = new ImageIcon(getClass().getResource("dcat.gif"));
      image6 = new ImageIcon(getClass().getResource("tailor.gif"));
  //    image0 = new ImageIcon(getClass().getResource("tailor.gif"));
      System.out.println("ready bilder");
      this.getContentPane().setLayout(borderLayout1);
      this.setSize(new Dimension(700, 500));
      this.setTitle("Client fr Evolve Plattform");
//      this.setIcon(image0);
      statusBar.setText(" ");

      An.setText("Anwendungen");
      viewDCAT.setRequestFocusEnabled(false);
      viewDCAT.setText("Beschreibung");
      viewDCAT.setIcon(image5);
      viewDCAT.setText(" Beschreibung ");
      viewDCAT.setToolTipText("DCAT, CAT und RBD Files ansehen");
      viewDCAT.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(ActionEvent e) {
            viewDCAT_actionPerformed(e);
         }
      });
      menuHelp.setText("Hilfe");
      menuFilecloseWin.setText("Fenster schliessen");
      anpassen.setRequestFocusEnabled(false);
      anpassen.setText("Anpassen");
      anpassen.setIcon(image6);
      anpassen.setText(" Anpassen "); 
      anpassen.setToolTipText("Anwendung anppasen");
      menuAppBeend.setText("Anwendung beenden");

      menuAppdelCache.setText("Cache lschen");
      menuAppdelCache.addActionListener(new ActionListener()  {
         public void actionPerformed(ActionEvent e) {
             DelCach_actionPerformed(e);
         }
      });
      menuAppBeend.addActionListener(new ActionListener()  {
         public void actionPerformed(ActionEvent e) {
            EndApp_actionPerformed(e);
         }
      });
      anpassen.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(ActionEvent e) {
            anpassen_actionPerformed(e);
         }
      });
      menuFilecloseWin.addActionListener(new ActionListener()  {
         public void actionPerformed(ActionEvent e) {
            closeWin_actionPerformed(e);
         }
      });
      menuHelpAbout1.setText("Info");
      menuHelpAbout1.addActionListener(new ActionListener()  {
         public void actionPerformed(ActionEvent e) {
            helpAbout_actionPerformed(e);
         }
      });
      mainPanel.setLayout(borderLayout2);
      menuFile.setText("Datei");
      menuFileExit2.setText("Evolve beenden");
      menuFileExit2.addActionListener(new ActionListener()  {
         public void actionPerformed(ActionEvent e) {
            fileExit_actionPerformed(e);
         }
      });
      menuFileNew.setText("Neues Fenster");
      menuFileNew.setActionCommand("c_newWin");
      menuFileNew.addActionListener(new ActionListener()  {
         public void actionPerformed(ActionEvent e) {
            newWin_actionPerformed(e);
         }
      });
      menuView.setText("Ansicht");
      menuAnsichtDCAT.setText("DCAT, CAT u. RBD");
      menuAnsichtDCAT.addActionListener(new ActionListener()  {
         public void actionPerformed(ActionEvent e) {
            viewDCAT_actionPerformed(e);
         }
      });
      menuViewClear.setText("Info Fenster lschen");
      menuViewClear.addActionListener(new ActionListener()  {
         public void actionPerformed(ActionEvent e) {
            viewClear_actionPerformed(e);
         }
      });

      newWin.setText(" ffnen ");
      newWin.setToolTipText("Neues Fenster ffnen");
      newWin.setIcon(image1);
      newWin.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(ActionEvent e) {
            newWin_actionPerformed(e);
         }
      });
      closeWin.setText(" Schliessen "); 
      closeWin.setToolTipText("Aktuelles Fenster schlieen");
      closeWin.setIcon(image2);
      closeWin.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(ActionEvent e) {
            closeWin_actionPerformed(e);
         }
      });
      EndApp.setText(" Beenden ");
      EndApp.setToolTipText("Aktuelle Anwendung beenden");
      EndApp.setIcon(image3);
      EndApp.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(ActionEvent e) {
            EndApp_actionPerformed(e);
         }
      });
      DelCach.setText(" Cache lschen ");
      DelCach.setIcon(image4);
      DelCach.setToolTipText("Alle Anwendungen im Hintergrund beenden");
      DelCach.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(ActionEvent e) {
            DelCach_actionPerformed(e);
         }
      });
      toolBar.add(newWin);
      toolBar.add(closeWin);
      toolBar.add(EndApp);
      toolBar.add(DelCach);
      toolBar.add(viewDCAT);
      toolBar.add(anpassen);
      menuFile.add(menuFileNew);
      menuFile.add(menuFilecloseWin);
      menuFile.addSeparator();
      menuFile.add(menuFileExit2);
      menuView.add(menuAnsichtDCAT);
      menuView.add(menuViewClear);
      menuBar.add(menuFile);
      menuBar.add(An);
      menuBar.add(menuView);
      menuBar.add(menuHelp);
      this.setJMenuBar(menuBar);
      this.getContentPane().add(toolBar, BorderLayout.NORTH);
      this.getContentPane().add(statusBar, BorderLayout.SOUTH);
      this.getContentPane().add(mainPanel, BorderLayout.CENTER);
      An.addSeparator();
      An.add(menuAppBeend);
      An.add(menuAppdelCache);


      menuHelp.add(menuHelpAbout1);
      
        lc = new JDesktopPane();
	     lc.setOpaque(false);
        lc.setBackground(new Color(255, 255, 255));
        JInternalFrame maker = createMakerFrame();

         mainPanel.add(lc);
        lc.add(createTextFrame(),JLayeredPane.MODAL_LAYER);  
        lc.add(maker, JLayeredPane.MODAL_LAYER);  
        try { maker.setSelected(true); } catch (Exception E) {};  
        maker.moveToFront();
        currentIFrame = maker;
        ClientInfo ci = (ClientInfo) innerWin.get(maker);
        currentClient = ci;
        setStatus("");


        
    }

   
//Aktion Datei | Beenden durchgefhrt
   
   public void createNewEntry(String name) {
      JMenuItem menuApp = new JMenuItem();      
      menuApp.setText(name);
      menuApp.setActionCommand(name);
      menuApp.addActionListener(new ActionListener()  {
         public void actionPerformed(ActionEvent e) {
            changeApp_actionPerformed(e, e.getActionCommand());
         }
      });
      An.add(menuApp);
   }

  public void changeApp_actionPerformed(ActionEvent e, String name) {
      if (currentIFrame == null) return;
      An.setPopupMenuVisible(false);
      menuBar.setSelected(null);
      An.setSelected(false);
      An.repaint();
      menuBar.repaint();
      //long start = (new Date()).getTime();         
      getApplication(name);
      currentIFrame.setTitle(currentClient.user+":"+currentClient.ID+" "+name);
     
      //long stop =  (new Date()).getTime();         
      lc.repaint();
      //message("info",1, "In " + (stop-start) + " ms.");
      setStatus("");
  }
   
   
   public void fileExit_actionPerformed(ActionEvent e) {
      ClientInfo ci = null;
      JInternalFrame ji = null;
      Hashtable iw = (Hashtable) innerWin.clone();
      for (Enumeration en = iw.keys(); en.hasMoreElements() ; ) {
         ji = (JInternalFrame) en.nextElement();
         ci = (ClientInfo) innerWin.get(ji);
         currentIFrame = ji;
         currentClient = ci;
         deleteCache();
         delApplication();
          try {
              server.goodByeServer(ci.user, ci.ID);
          } catch (Exception re) {
             message("error", 1, "ClientFrame: " + re);
          }

      }
      try {
            server.goodByeServer(user, ID);
      } catch (Exception re) {
	         message("error", 1, "ClientFrame: " + re);
      }
      System.exit(0);
   }
//Aktion Hilfe | Info durchgefhrt
   
   public void helpAbout_actionPerformed(ActionEvent e) {
   }
//berschreiben, damit das Programm bei System Close beendet werden kann
   
   protected void processWindowEvent(WindowEvent e) {
      super.processWindowEvent(e);
      if (e.getID() == WindowEvent.WINDOW_CLOSING) {
         fileExit_actionPerformed(null);
      }
   }

   void newWin_actionPerformed(ActionEvent e) {
     JInternalFrame maker = createMakerFrame();
     lc.add(maker, JLayeredPane.MODAL_LAYER);  
     maker.moveToFront();
    currentIFrame = maker;
     setStatus("");
     try { maker.setSelected(true); } catch (Exception E) {};  
  
 }

   void closeWin_actionPerformed(ActionEvent e) {
      if (currentIFrame == null) return;
      deleteCache();
      delApplication();
      try {
          server.goodByeServer(currentClient.user, currentClient.ID);
      } catch (Exception re) {
          message("error", 1, "ClientFrame: " + re);
      }
      innerWin.remove(currentIFrame);
      currentIFrame.dispose();
      currentIFrame = null;
      currentClient = null;
        setStatus("");
 }

   void EndApp_actionPerformed(ActionEvent e) {
      if (currentIFrame == null) return;
      delApplication();
      currentIFrame.setTitle(currentClient.user+":"+currentClient.ID);
      currentIFrame.repaint();
      setStatus("");
   }

   void DelCach_actionPerformed(ActionEvent e) {
      if (currentIFrame == null) return;
      deleteCache();
      setStatus("");
  }

   void viewDCAT_actionPerformed(ActionEvent e) {
      if (currentIFrame == null) return;
      showDCAT();
   }

   void viewClear_actionPerformed(ActionEvent e) {
      infoArea.setText("");
   }

   void anpassen_actionPerformed(ActionEvent e) {
      if (currentIFrame == null) return;
      System.out.println("MICHAEL!!!");
   }

/*   void mainPanel_mouseMoved(MouseEvent e) {
   }

   void mainPanel_mouseDragged(MouseEvent e) {
   }
  */
    public JInternalFrame createTextFrame() {
        JInternalFrame w;
        JPanel tp;
        Container contentPane;
        
        w = new JInternalFrame("Info");

        contentPane = w.getContentPane();
        contentPane.setLayout(new GridLayout(0, 1));
        tp = new JPanel();
        tp.setLayout(new BorderLayout());
        infoArea.setEditable(false);
        tp.add(infoArea, BorderLayout.CENTER);
        JScrollPane sp = new JScrollPane(tp);
        contentPane.add(sp);
        w.setBounds(0,0, 500, 400);
        w.setResizable(true);
        w.setClosable(false);
        w.setMaximizable(true);
        w.setIconifiable(true);
  //      w.setBounds(20*(makeCount%10), 20*(makeCount%10), 225, 150);

           return w;
    }

    public JInternalFrame createMakerFrame() {
        JInternalFrame w;
        JPanel tp;
        Container contentPane;
        
        w = new JInternalFrame("Frame Creator");
        //contentPane.setLayout(new GridLayout(0, 1));
        tp = new JPanel(null);

        tp.setBackground(new Color(230, 230, 255));
        tp.addMouseMotionListener(new myMouseListener());
        JScrollPane sp = new JScrollPane();
        sp.getViewport().add(tp);
        w.getContentPane().add(sp);

        w.setBounds((fcount%10)*30 , (fcount%10)*30, 500, 400);
        fcount++;
        w.setResizable(true);
        w.setClosable(false);
        w.setMaximizable(true);
        w.setIconifiable(true);
        w.addInternalFrameListener(new MyIFrameListener());     
        ClientInfo ci = new ClientInfo(user, "id", tp);
        try {
            ci.ID = server.getID(user, ID);
        } catch (Exception ex) {
            message("error",1,"new Appl: "+ex);
        }
        innerWin.put(w, ci);

        currentClient = ci;
        currentIFrame = w;
        w.setTitle(currentClient.user+":"+currentClient.ID);
        return w;
    }

   public class MyIFrameListener implements InternalFrameListener {
      public void  internalFrameOpened(InternalFrameEvent e) {
         //System.out.println("open");
        }
      public void internalFrameClosing(InternalFrameEvent e) {
           //    System.out.println("close");
      }
      public void internalFrameClosed(InternalFrameEvent e) {
            //   System.out.println("closed");
      }
      public void internalFrameIconified(InternalFrameEvent e) {
             //  System.out.println("icon");
      }
      public void internalFrameDeiconified(InternalFrameEvent e) {
             //  System.out.println("deicon");
      }
      public void internalFrameActivated(InternalFrameEvent e) {     
            JInternalFrame o = (JInternalFrame) e.getSource();
            ClientInfo ci = (ClientInfo) innerWin.get(o);
            currentClient = ci;
            currentIFrame = o;
            setStatus("");
      }
      public void internalFrameDeactivated(InternalFrameEvent e) {

      }
   };

    public class  myMouseListener implements MouseMotionListener {
       public void mouseMoved(MouseEvent e) {
            p = e.getPoint();
            //statusBar.setForeground(new Color (0, 0, 0));
            statusBar.setText(status + "   |      (" + p.x + "," + p.y +") ");
        }
        public void mouseDragged(MouseEvent e) {
            //statusBar.setForeground(new Color(250,100, 100));
            statusBar.setText(status + "   |      (" + (e.getX()- p.x) + "," + (e.getY() -p.y) +") ");
            //
        }
   };

   
 public void message(String typ, int level, String m) {
       infoArea.append(m+"\n");
  }

  void br() { infoArea.append("##################################################\n");}
  void hr() { infoArea.append("__________________________________________________\n");}
  

  public Container getPanel() { return currentClient.panel;}

 private void getApplication(String dateiName) {
   infoArea.setText(dateiName + ":\n");
   IR_DistComponent dc  = null;
   IR_DistComponent dcs = null;
   IR_Component     c   = null;
   String           CAT = null;
   String          DCAT = null;
   ClientInfo ci = currentClient;

   if (ci.currentProxy != null) ci.currentProxy.hide();
   if (ci.proxy.containsKey(dateiName)) {
      ci.currentProxy = (Proxy) ci.proxy.get(dateiName);
      ci.currentProxy.show();
      ci.currentDistComp = (IR_DistComponent) ci.distComps.get(dateiName);
      ci.currentDCATName = dateiName;
   } else {
      try {
         long start = (new Date()).getTime();         
         dc = server.getNewApplication(ci.user, ci.ID, dateiName);
     	   if (dc!= null) infoArea.append("DistComponente " + server.getDCATName(user, dateiName) + " bekommen.\n");
         else {
           infoArea.append("Keine DistComponente bekommen.\n");
           return;
         }
       	if (dc != null) {
           c = dc.getComponent();
           if (c != null) {
              if (ci.currentProxy != null) {
                  ci.currentProxy.hide();
               // server.removeDistComponent(user, currentDCATName);
              }
              infoArea.append("Erzeuge Proxy Objekte.\n");
              ci.currentDCATName = dateiName;
              //currentPanel.setTitle(user+":"+ID + " " + dateiName);
              ci.currentProxy = new Proxy(c, this, true);
              ci.currentDistComp = dc;
              ci.proxy.put(dateiName, ci.currentProxy);
              ci.distComps.put(dateiName, ci.currentDistComp);
              dc.setProxy(ci.currentProxy);
              dc.bindAll();
              long stop = (new Date()).getTime();         
              infoArea.append("In " + (stop-start) + " ms. ("+dateiName+")");
              //message("info",2,"Fertig.");
           }  else {
              infoArea.append("Keine lokale Komponente bekommen.\n");
              return;
          }
        } // end dc != null
     } catch (Exception re) {
	         message("error", 1, "Client.getApplication: " + re);
     }
   }
}

/** Meldet alle gespeicherten DCATs beim Server ab und entfernt die Proxyobjekte aus dem
    Cache. Dabei wird die aktuelle Anwendung nicht abgemeldet bzw. aus dem Cache entfernt.
*/
private void deleteCache() {
   String name = null;
   ClientInfo ci = currentClient;

   for (Enumeration e=ci.distComps.keys();e.hasMoreElements() ; ) {
       name = (String) e.nextElement();
       if (!name.equals(ci.currentDCATName)) {
          try {
              server.removeApplication(ci.user, ci.ID, name);
              message("info", 2, "Lsche " + name + " fr " + ci.user + ":"+ ci.ID + 
                        " aus dem cache.");
          } catch (RemoteException re) {
               message("error", 1, "deleteCache: " + re.toString());
          }
       }
   }
   message("info",2,"Fertig.");
   ci.proxy     = new Hashtable();
   ci.distComps = new Hashtable();
   if (ci.currentProxy != null) {
      ci.proxy.put(ci.currentDCATName, ci.currentProxy);
      ci.distComps.put(ci.currentDCATName, ci.currentDistComp);
   }
}

    private void delApplication() {
     ClientInfo ci = currentClient;
     if (ci.currentProxy==null) return;
     try {
         server.removeApplication(ci.user, ci.ID, ci.currentDCATName);
         ci.proxy.remove(ci.currentDCATName);
         ci.distComps.remove(ci.currentDCATName);
     } catch (RemoteException re) {
         message("error", 1, "deleteApplication: " + re.toString());
    }
    ci.currentProxy.hide();
//    infoArea.setText("");
    ci.currentDCATName=null;
    ci.currentDistComp=null;
    ci.currentProxy=null;
    //c22.04.99urrentPanel.setTitle(user+":"+ID);
}

  
 private void showDCAT() {
      ClientInfo ci = currentClient;
   IR_DistComponent dc  = ci.currentDistComp;
   IR_DistComponent dcs = null;
   IR_Component     c   = null;
   String           CAT = null;
   String          DCAT = null;
   try {
        if (ci.currentDistComp == null) return;
        infoArea.append("Versuche " + ci.currentDCATName + ".DCAT zu erzeugen:\n");
        hr();
        DCAT = dc.writeDistComponent();
        if (DCAT != null) infoArea.append(DCAT);
        br();
        c = dc.getComponent();    	  
        if (c != null) {
           infoArea.append("Versuche  " + c.getTypeName() + ".CAT zu erzeugen:\n");
           hr();
           CAT = c.toText();
           if (CAT != null) infoArea.append(CAT);
           br();
  
           for (Enumeration e2 = dc.getLinkedDistComps().elements(); e2.hasMoreElements();) {
           	  infoArea.append("Verbundene DistComponenten:\n");
              dcs = (IR_DistComponent) e2.nextElement();
              c = dcs.getComponent();
           	  infoArea.append(c.getTypeName() +".CAT : \n");
              hr();
              if (c != null) {
                 CAT = c.toText();
                 if (CAT != null) infoArea.append(CAT);
              }
              br();
           }

          IR_RBD rbd = null;
          for ( Enumeration e2 = dc.getMyRBDs().elements(); e2.hasMoreElements();) {
           	  infoArea.append("Remote Binds :\n");
              rbd = (IR_RBD) e2.nextElement();
              if (rbd != null) {
            	  infoArea.append("Versuche "  + rbd.getName()+".RBD zu erzeugen:\n");
                 hr();
                 CAT = rbd.write();
                 if (CAT != null) infoArea.append(CAT);
              }
              br();
           }
         // infoArea.append("Speicher alles nach d:/.\n");
         // server.saveDistComponent(dc, "d:/");
         // infoArea.append("Melde DCAT wieder ab.\n");
         // server.removeDistComponent(user, dateiName);
         // infoArea.append("********************  O K  **************************\n");
        
               
//    	infoArea.select(0,0);
      }

      } catch (Exception re) {
	         message("error", 1, "Client: " + re);
      }
 }
 
public void setStatus(String s) {
   status = "";
   if (currentClient != null) {
      if (currentClient.currentDCATName!=null) status += currentClient.currentDCATName + " im Client " ;       
      status += currentClient.user+":"+currentClient.ID+" ";
    }
    status += "  " + s;
    statusBar.setText(status + "   |      (" + p.x + "," + p.y +") ");
}

  public URLClassLoader getURLClassLoader(){ return ucl;}
//public boolean existID
  public String getUser() { return user;}
  public String getID() { return ID;}

} ///:~

                                                  
