// The "freEvolve System" is a platform supporting the reconfiguration of 
// component-based applications'
// Copyright (C) 1999  Ralph Hinken and Dr. Oliver Stiemerling
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Version: 1.0
// Date:    09.10.2001
//
// History:
//

package org.freevolve.client;

import org.freevolve.server.*;
import java.net.*;
import java.rmi.*;
import java.awt.*;
import java.io.*;
import java.util.*;
import java.lang.reflect.*;

public class startSwing
{
  String iniFileName = "EvolveClient.ini";
  String URLTag      = "EvolveServerURL";
  String userTag     = "DefaultUserName";
                     
  private String getProp(String tag) {
    File f;
    FileInputStream fis = null;
    try {
      f = new File(".", iniFileName);
      if (f==null) {
          System.out.println("File not found " + iniFileName);
      }
      fis = new FileInputStream(f);
      PropertyResourceBundle props = new PropertyResourceBundle(fis);
      return props.getString(tag);
    } catch (IOException e) {
      System.err.println("startSwing.IOFehler: " + e.getClass().getName() + ": " + e.getMessage());
      return null;
    }
    finally { try { if (fis != null) fis.close();  } catch (IOException e) {}  }
  }

  URL[] readClassPath(String url) {
    Vector v = new Vector();
    StringTokenizer token = new StringTokenizer(url, ";");    
    String value;
    int i = 0;
    // First read all components
    while (token.hasMoreTokens()) {
      if (!token.hasMoreTokens()) continue;
      value = token.nextToken();
      v.add(value);
      i++;
    }
    URL[] u = new URL[i];
    i=0;
    for (Enumeration e = v.elements(); e.hasMoreElements(); ) {
        try {
            u[i] = new URL((String) e.nextElement());
        } catch (java.net.MalformedURLException ex) {
            System.out.println("readClassPath: URL "+u[i]+" hat falsches Format.");
        }
        i++;        
    }
    return u;  
  };


	public static void main(String[] args) 
	{
   startSwing s = new startSwing();
   try {
      System.setSecurityManager(new RMISecurityManager());
      URL[] u = null;
      String url = s.getProp(s.URLTag);
      if (url == null) {
          System.out.println("Es fehlt der Eintrag "+s.URLTag+" in Datei "+s.iniFileName);
          url = "hkm.cs.uni-bonn.de";
      }
      //u[0] = new URL(url);
      u = s.readClassPath(url);
      String serverName = u[0].getHost();

      IR_URLgetter server = (IR_URLgetter) Naming.lookup("rmi://" + serverName + "/EvolveServer");
      URL[] addURLs = server.getEvolveURLs();
      URLClassLoader ucl = new URLClassLoader(addURLs);
      
      //URLClassLoader ucl = new URLClassLoader(u);
      System.out.println("URLClassLoader gestartet fr " + url);
      Class klasse  = Class.forName("org.freevolve.client.ClientFrame", true, ucl);
      System.out.println("Klasse gefunden.");
      String user = s.getProp(s.userTag);
      String ID  = "";
      if (args.length == 0) {
         if (user==null) {
            user = "hinken";
         }
         System.err.println("Aufruf: java startSwing <user> <ID> , take "+user);
      } else {
         if (args.length>0)  user      = args[0];
         if (args.length>1)  ID        = args[1];
      }
      EvolveClient client = (EvolveClient) klasse.newInstance();
      System.out.println("Habe EvolveClient gestartet");
      client.ini(serverName, user, ID, ucl);
      
    } catch (Exception e) {
      System.out.println("SwingClient: " + e);
    }
	}
}
