// The "freEvolve System" is a platform supporting the reconfiguration of 
// component-based applications'
// Copyright (C) 1999  Ralph Hinken and Dr. Oliver Stiemerling
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Version: 1.0
// Date:    09.10.2001
//
// History:
//

package org.freevolve.client;

import org.freevolve.server.*;
import java.rmi.*;
import java.awt.*;
import java.io.*;
import java.util.*;
import java.lang.reflect.*;
import java.net.*;
import java.awt.event.*;

public class t_show implements  EvolveClient {
  IR_Server   server = null;

  public void ini(String server, String user, String ID, URLClassLoader ul) {
    String serverName = server;
    try {
      System.setSecurityManager(new RMISecurityManager());
      this.server = (IR_Server) Naming.lookup("rmi://" + serverName + "/EvolveServer");
      System.out.println("An Evolve Server angebunden. Starte Anpassung.");
      IR_DistComponent dc = this.server.getDistComponent(user, ID, "ListClientChef");
      if (dc != null) {

        showDCAT(dc);
        System.out.println("Anpassung beendet.");
      } else
        System.out.println("no sorry, kein DistComponent bekommen fr "+user+":"+ID);
    } catch (Exception e) {
      System.out.println("tailor2: " + e);
    }
  };

 private void showDCAT(IR_DistComponent dc) {
   IR_DistComponent dcs = null;
   IR_Component     c   = null;
   String           CAT = null;
   String          DCAT = null;
   try {
        System.out.println("Versuche " + dc.getName() + ".DCAT zu erzeugen:\n");
        hr();
        DCAT = dc.writeDistComponent();
        if (DCAT != null) System.out.println(DCAT);
        br();
        c = dc.getComponent();    	  
        if (c != null) {
           System.out.println("Versuche  " + c.getTypeName() + ".CAT zu erzeugen:\n");
           hr();
           CAT = c.toText();
           if (CAT != null) System.out.println(CAT);
           br();
  
           for (Enumeration e2 = dc.getLinkedDistComps().elements(); e2.hasMoreElements();) {
           	  System.out.println("Verbundene DistComponenten:\n");
              dcs = (IR_DistComponent) e2.nextElement();
              c = dcs.getComponent();
              System.out.println(c.getTypeName() +".CAT : \n");
              hr();
              if (c != null) {
                 CAT = c.toText();
                 if (CAT != null) System.out.println(CAT);
              }
              br();
           }

          IR_RBD rbd = null;
          for ( Enumeration e2 = dc.getMyRBDs().elements(); e2.hasMoreElements();) {
           	  System.out.println("Remote Binds :\n");
              rbd = (IR_RBD) e2.nextElement();
              if (rbd != null) {
            	  System.out.println("Versuche "  + rbd.getName()+".RBD zu erzeugen:\n");
                 hr();
                 CAT = rbd.write();
                 if (CAT != null) System.out.println(CAT);
              }
              br();
           }

        
               
//    	infoArea.select(0,0);
      }

      } catch (Exception re) {
	        System.out.println("ERROR: tailor2: " + re);
      }
 }

    public void hr() {;}
    public void br() {System.out.println("===================================================================");}

  }
  