// The "freEvolve System" is a platform supporting the reconfiguration of 
// component-based applications'
// Copyright (C) 1999  Ralph Hinken and Dr. Oliver Stiemerling
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Version: 1.0
// Date:    09.10.2001
//
// History:
//

package org.freevolve.server;
/*
    A basic extension of the java.awt.Frame class
 */

import java.awt.*;
import java.util.*;

public class EvolveMsg extends Frame {
    boolean debug = false;

   public EvolveMsg(Server s, boolean debug) {
        this.debug = debug;
        msgs = new Vector();
        server = s;
      setSize(800,600);
      setLayout(new BorderLayout());
      addNotify();
       Panel panelL = new Panel();
       panelL.setLayout(new BorderLayout());
       panelL.setBounds(0,0,200,600);
       Panel panelR = new Panel();
       panelR.setLayout(new BorderLayout());
       Panel panelD = new Panel();
       panelD.setLayout(new BorderLayout());
       Panel panelO = new Panel();
       panelO.setLayout(null);
       panelO.setBounds(0,0,250,340);
       Panel panelU = new Panel();
       panelU.setLayout(new BorderLayout());
//       panelU.setBounds(0,0,250,0);

      msg = new java.awt.TextArea();
      msg.setBounds(0,0,500,600);
      panelR.add(msg, BorderLayout.CENTER);
      error = new java.awt.TextArea();
      error.setBounds(0,450,500,100);
      panelD.add(error, BorderLayout.CENTER);
      user = new java.awt.TextArea(50,30);
//      user.setBounds(0,0,20,300);
      panelU.add(user, BorderLayout.CENTER);
      label1 = new java.awt.Label("   Evolve Monitor");
      label1.setBounds(12, 12,220,36);
      label1.setFont(new Font("Dialog", Font.BOLD, 24));
      label1.setBackground(new Color (220,220,255));
      panelO.add(label1);

      b_exit = new java.awt.Button("Exit");
      b_exit.setBounds( 24, 300,84,24);
      panelO.add(b_exit);
      b_reset = new java.awt.Button("Reset");
      b_reset.setBounds(24, 258,84,24);
      panelO.add(b_reset);
      b_clear = new java.awt.Button("Clear");
      b_clear.setBounds( 24,234,84,24);
      panelO.add(b_clear);
      b_show = new java.awt.Button("Show all");
      b_show.setBounds( 24, 210,84,24);
      panelO.add(b_show);
      
      label2 = new java.awt.Label(" Fehlermeldungen");
//      label2.setBounds(0,400,250,36);
      label2.setFont(new Font("Dialog", Font.BOLD, 24));
      panelD.add(label2,  BorderLayout.NORTH);
      label3 = new java.awt.Label("  Serverobjekte");
      label3.setBounds(12, 0,180,36);
      label3.setFont(new Font("Dialog", Font.BOLD, 24));
      label3.setForeground(new Color(0));
      panelU.add(label3, BorderLayout.NORTH);
      c_comp = new java.awt.Checkbox("Component");
      c_comp.setBounds( 24, 60,144,24);
      panelO.add(c_comp);
      c_comp.setState(true);
      c_dcomp = new java.awt.Checkbox("DistComponent");
      c_dcomp.setBounds(24, 84,144,24);
      panelO.add(c_dcomp);
      c_dcomp.setState(true);
      c_rbind = new java.awt.Checkbox("Remote Binds");
      c_rbind.setBounds(24,108,144,24);
      panelO.add(c_rbind);
      c_rbind.setState(true);
      c_info = new java.awt.Checkbox("allg. Informationen");
      c_info.setBounds( 24,156,144,24);
      panelO.add(c_info);
      c_info.setState(true);
      c_debug = new java.awt.Checkbox("debug Informationen");
      c_debug.setBounds( 24, 180,144,24);
      panelO.add(c_debug);
      c_debug.setState(true);
      setTitle("Evolve Monitor");
      setResizable(true);
      
      panelL.add(panelO, BorderLayout.NORTH);
      panelL.add(panelU, BorderLayout.CENTER);
      panelR.add(panelD, BorderLayout.SOUTH);
      this.add  (panelL,     BorderLayout.WEST);
      this.add  (panelR,     BorderLayout.CENTER);

      //}}

      //{{INIT_MENUS
      //}}
   }

   public EvolveMsg(String title, Server s, boolean debug) {
       this(s, debug);
       setTitle(title);
   }

    public synchronized void show() {
      setLocation(50, 50);
      super.show();
    }

   public boolean handleEvent(Event event) {
      if (event.target == b_reset && event.id == Event.ACTION_EVENT) {
         msgs = new Vector();
         showAllMsg();
         try  { 
            server.reset();
         } catch (java.rmi.RemoteException ex) {
            System.out.println("EvolveMsg: " +ex);
         }
         return true;
      }

      if (event.target == b_show && event.id == Event.ACTION_EVENT) {
         showAllMsg();
         return true;
      }
      if (event.target == b_clear && event.id == Event.ACTION_EVENT) {
         clearMsg();
         return true;
      }
      if (event.target == b_exit && event.id == Event.ACTION_EVENT) {
               //dispose();
               setVisible(false);
               return false;
            }
      return super.handleEvent(event);
   }

    public void add(String type, int level, String text) {
        Msg m = new Msg(type, level, text + "\n");
        if (!type.equals("server")) msgs.addElement(m);
        showMsg(m);
    }

    private void showMsg(Msg m) {
        // Error-msg?
        if (m.getType().equals("error")) error.append(m.getText());
        // User-msg?     
        
        else if (m.getType().equals("server")) user.setText(m.getText());
        // weg:
        
        else if ( debug && ((m.getType().equals("comp") && c_comp.getState()) ||
                 (m.getType().equals("dcomp") && c_dcomp.getState()) ||
                 (m.getType().equals("rbind") && c_rbind.getState()) ||
                 (m.getType().equals("proxy") && c_rbind.getState()))) {
                    if ((m.getLevel() >= 5 && c_debug.getState()) ||
                        (m.getLevel() == 4 && c_info.getState()) ||
                        (m.getLevel() <4))
                            msg.append(m.getText());
                 }
         // bis hier
         

    }

    private void clearMsg() {
        error.setText("");
        msg.setText("");
    }

    private void showAllMsg() {
        clearMsg();
        Msg m = null;
        for(Enumeration e=msgs.elements(); e.hasMoreElements(); ) {
            m = (Msg) e.nextElement();
            showMsg(m);
         }
    }
   //{{DECLARE_CONTROLS
   java.awt.TextArea msg;
   java.awt.TextArea error;
   java.awt.TextArea user;
   java.awt.Label label1;
   java.awt.Button b_exit;
   java.awt.Button b_clear;
   java.awt.Button b_show;
   java.awt.Button b_reset;
   java.awt.Label label2;
   java.awt.Label label3;
   java.awt.Checkbox c_comp;
   java.awt.Checkbox c_dcomp;
   java.awt.Checkbox c_rbind;
   java.awt.Checkbox c_info;
   java.awt.Checkbox c_debug;
   //}}
    Vector msgs;
    Server server;

   //{{DECLARE_MENUS
   //}}
}
