// The "freEvolve System" is a platform supporting the reconfiguration of 
// component-based applications'
// Copyright (C) 1999  Ralph Hinken and Dr. Oliver Stiemerling
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Version: 1.0
// Date:    09.10.2001
//
// History:
//

package org.freevolve.server;

import java.util.*;
import java.rmi.*;

// bei addRBD -> verdrahten !!
// bei removeRBD -> entdrahten !!
/**
  Remote Interface, dass nur von der Klasse DistComponent instanziiert wird.
   
  @see DistComponent
  */
public interface IR_DistComponent  extends Remote  {

  public String       getId             () throws RemoteException ;
  public String       getUserName       () throws RemoteException;
  public IR_Component getComponent      () throws RemoteException;
  //  public    Proxy     getProxy() throws RemoteException  ;
  public String       getName           () throws RemoteException  ;
  public    String    getLocalName      () throws RemoteException  ;
  public Vector       getLinkedDistComps() throws RemoteException; // IR_DistComponent;
  public IR_Proxy     getProxy()           throws RemoteException; 
  public void         setProxy(IR_Proxy proxy)   throws RemoteException; 
  public boolean      usedDistComponent (IR_DistComponent c) throws RemoteException;
  public boolean      isConnected       (IR_DistComponent c) throws RemoteException;
  public boolean      hasPort           (String p)           throws RemoteException;

  public void   addLinkedDistComponent  (IR_DistComponent c) throws RemoteException;
  // erst Verbindungen trennen, dann abmelden
  public void   removeLinkedDistComponent(IR_DistComponent c) throws RemoteException;
  // Neue RBD, die moeglichst noch nicht als Datei existiert, hinzufuegen;
  public IR_RBD addNewRBD(IR_DistComponent otherDistComp, String rbdName) throws RemoteException;
  // RBD, die als Datei existiert, hinzufuegen;
  public IR_RBD addRBD(IR_DistComponent otherDistComp, String rbdName, String rbdString) throws RemoteException;
  // Alle RBDs entfernen, die uns gehoeren und die uns mit otherDistComp verbinden...;
  public void removeRBD(IR_DistComponent otherDistComp) throws RemoteException;
  // Spezielle RBD entfernen, die uns mit otherDistComp verbindet..;
  public void  removeRBD(IR_DistComponent otherDistComp, String rbdName) throws RemoteException;

  // Beide nicht benutzen!!
  public void removeRBD(IR_RBD r) throws RemoteException;
  public void addRBD(IR_RBD r) throws RemoteException;

  // port1 soll mir gehoeren...;
  public void bind (String port1, String port2, IR_RBD r) throws RemoteException;
  // port1 soll mir gehoeren...;
  public void unbind (String port1, String port2, IR_RBD r) throws RemoteException;
  // Nur unsere RBDs, die wir erzeugt haben. Bei denen ist DistCompOne==this;
  public boolean     bindAll()    throws RemoteException;
  public boolean     unbindAll()  throws RemoteException;
  public Vector      getMyRBDs () throws RemoteException;

  public Vector      getOtherRBDs () throws RemoteException;
  // Alle RBDs, die uns gehoeren und uns mit der DistComponent c verbinden;
  public Vector      getRBDs (IR_DistComponent c) throws RemoteException;
  // Eindeutige Indentifizierung von RBD !;
  // RBD  von this mit otherDistComp und Name rbdName zurueckgeben;
  // rbdName == null dann Name egal...;
  public IR_RBD getRBD(IR_DistComponent otherDistComp, String rbdName) throws RemoteException;

  public IR_DistComponent getOtherDistComp(String name) throws RemoteException;
  public void kill() throws RemoteException;
  public String writeDistComponent()  throws RemoteException;
} // END CLASS IR_DistComponent ;

