// The "freEvolve System" is a platform supporting the reconfiguration of 
// component-based applications'
// Copyright (C) 1999  Ralph Hinken and Dr. Oliver Stiemerling
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Version: 1.0
// Date:    09.10.2001
//
// History:
//

package org.freevolve.server;
import java.util.*;
import java.rmi.*;

/** Remote Interface, da nur von Param implementiert wird.
  @see Param
  */
public interface IR_Param extends Remote { 

  public String  getName()              throws RemoteException;
  public String  getType()              throws RemoteException;
  public IR_Component getOwner()        throws RemoteException; 

  public String  print()                throws RemoteException;
  public void    setName(String name)   throws RemoteException;
  public void    setValue(String value) throws RemoteException;
  public void    setValue(double value) throws RemoteException;
  public void    setValue(char   value) throws RemoteException;
  public void    setType(String type)    throws RemoteException;
  public String  getSValue()            throws RemoteException;
  public double  getNValue()            throws RemoteException;
  public char    getCValue()            throws RemoteException;
  public Object  getValue()             throws RemoteException;

  public boolean isConnected(IR_Component comp) throws RemoteException;
  public boolean isValueSet ()          throws RemoteException;
  public boolean hasSuperValue()        throws RemoteException;
  public void    unSetValue()           throws RemoteException;

  public String  getSubCompName()                  throws RemoteException;
  public void    setSubCompName(String localName)  throws RemoteException;
  public boolean isSubCompParam()                  throws RemoteException;
  public void    setSuperParam(IR_Param p)         throws RemoteException;
  public IR_Param getSuperParam()                  throws RemoteException;

  public void    addBinding   (IR_ParamBinding p)  throws RemoteException;
  public void    removeBinding(IR_ParamBinding p)  throws RemoteException;
  public Vector      getBindings   ()              throws RemoteException;
}
