// The "freEvolve System" is a platform supporting the reconfiguration of 
// component-based applications'
// Copyright (C) 1999  Ralph Hinken and Dr. Oliver Stiemerling
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Version: 1.0
// Date:    09.10.2001
//
// History:
//

package org.freevolve.server;
import java.util.*;
import java.rmi.*;
/**
  Remote Interface, da nur von der Klasse ParamBinding instanziiert wird.
   
  @see ParamBinding
  */
public interface IR_ParamBinding  extends Remote {

  public IR_Param     getParamOne()         throws RemoteException;
  public IR_Param     getParamTwo()         throws RemoteException;
  public String       getParamNameOne()     throws RemoteException;
  public String       getParamNameTwo()     throws RemoteException;

  public IR_Component getComponentOne()     throws RemoteException;
  public IR_Component getComponentTwo()     throws RemoteException;
  public String       getInstanceNameOne()  throws RemoteException;
  public String       getInstanceNameTwo()  throws RemoteException;
  public IR_Component getOwner()            throws RemoteException;
  public String       toTxt()               throws RemoteException;
  public boolean      isSymmetric()         throws RemoteException;

  public boolean      connects(IR_Component cOne, IR_Component cTwo) throws RemoteException;
  public boolean      connectsComp(String local_name) throws RemoteException;
  public boolean      isParamBinding(String oneComp, String oneParam, String twoComp, String twoParam) throws RemoteException;
  public boolean      isParamBinding(IR_Param oneParam, IR_Param twoParam) throws RemoteException;




}
