// The "freEvolve System" is a platform supporting the reconfiguration of 
// component-based applications'
// Copyright (C) 1999  Ralph Hinken and Dr. Oliver Stiemerling
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Version: 1.0
// Date:    09.10.2001
//
// History:
//

package org.freevolve.server;
import java.util.*;
import java.rmi.*;

// for intern use only
/**
  Remote Interface, da nur von der Klasse Port instanziiert wird.

  @see Port
  */
public interface IR_Port  extends Remote{
  public String         getName () throws RemoteException;
  public void           setName(String name) throws RemoteException;
  public String         getType () throws RemoteException;
  public IR_Component   getOwner() throws RemoteException;
  public String         print   () throws RemoteException;
  public void           setPolarity(String p)  throws RemoteException;
  public void           setProtocol(String p)  throws RemoteException;
  public String         getPolarity()          throws RemoteException;
  public String         getProtocol()          throws RemoteException;

  public void        addBinding   (IR_PortBinding p)  throws RemoteException;
  public void        removeBinding(IR_PortBinding p)  throws RemoteException;
  public Vector      getBindings   ()                  throws RemoteException;
}
