// The "freEvolve System" is a platform supporting the reconfiguration of 
// component-based applications'
// Copyright (C) 1999  Ralph Hinken and Dr. Oliver Stiemerling
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Version: 1.0
// Date:    09.10.2001
//
// History:
//

package org.freevolve.server;
import java.util.*;
import java.rmi.*;
import java.lang.reflect.*;

/** Remote Interface, da nur von PortProxy implementiert wird.
  @see PortProxy
  */
public interface IR_PortProxy extends Remote { 

  public String  getName()                      throws RemoteException;
  public String  getType()                      throws RemoteException;
  public String  getPolarity()                  throws RemoteException;
  public void    setEvent(boolean b)            throws RemoteException;
  public IR_Proxy getOwner()                     throws RemoteException;
  public boolean isEvent()                      throws RemoteException;
  public boolean isBeanPort()                   throws RemoteException;
  public Method  getGetMethod()                 throws RemoteException;
  public Method  getAddMethod()                 throws RemoteException;
  public Method  getRemoveMethod()              throws RemoteException;
  public Vector  getHorizontalPorts()           throws RemoteException;
  public Vector  getUpPorts()                   throws RemoteException;
  public Vector  getDownPorts()                 throws RemoteException;
  public Vector  getHorConnected()              throws RemoteException;
  public Vector  getLeafPorts()                 throws RemoteException;   

  public Object  invokeGet()                    throws RemoteException;   
  public boolean invokeAdd(Object ob)           throws RemoteException;   
  public boolean invokeRemove(Object ob)        throws RemoteException;   

  public boolean addHorizontal   (IR_PortProxy pp) throws RemoteException;
  public boolean removeHorizontal(IR_PortProxy pp) throws RemoteException;
  public boolean addUp           (IR_PortProxy pp) throws RemoteException;
  public boolean addDown         (IR_PortProxy pp) throws RemoteException;
  public boolean removeUp        (IR_PortProxy pp) throws RemoteException;
  public boolean removeDown      (IR_PortProxy pp) throws RemoteException;

  public String  toTxt()                        throws RemoteException;
  public boolean readFunctions(Class klasse)     throws RemoteException;
}
