// The "freEvolve System" is a platform supporting the reconfiguration of 
// component-based applications'
// Copyright (C) 1999  Ralph Hinken and Dr. Oliver Stiemerling
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Version: 1.0
// Date:    09.10.2001
//
// History:
//

package org.freevolve.server;
import java.util.*;
import java.rmi.*;

/** Remote Interface, da nur von Param implementiert wird.
  @see Param
  */
public interface IR_Proxy extends Remote { 

  public String       getName()              throws RemoteException;
  public String       getType()              throws RemoteException;
  public IR_PortProxy getPort(String name)   throws RemoteException;
  public Object       getObject()            throws RemoteException;

  public void      addSubProxy(IR_Component c)  throws RemoteException;
  public void      addPortProxy(IR_Port p)      throws RemoteException;
  public void      addParamProxy(IR_Param p)    throws RemoteException;

  public void      removeSubProxy(String localName)  throws RemoteException;
  public void      removePortProxy(String name)      throws RemoteException;
  public void      removeParamProxy(String name)     throws RemoteException;

  public void      setParam(String name, Object value)  throws RemoteException;
  public void      unsetParam(String name)              throws RemoteException;

  public boolean      bindPorts  (String c1, String p1, String c2, String p2)   throws RemoteException;
  public boolean      unbindPorts(String c1, String p1, String c2, String p2)   throws RemoteException;

  public boolean      bindParams  (String p1, String c2, String p2)  throws RemoteException;
  public boolean      unbindParams(String p1, String c2, String p2)  throws RemoteException;

  public void   changeTypeName        (String newTypeName)              throws RemoteException; 
  public void changePortName        (String oldName, String newName)  throws RemoteException;
  public void changeParamName       (String oldName, String newName)  throws RemoteException;
  public void changeSubComponentName(String oldName, String newOne)   throws RemoteException;

  public void kill () throws RemoteException;
}
