// The "freEvolve System" is a platform supporting the reconfiguration of 
// component-based applications'
// Copyright (C) 1999  Ralph Hinken and Dr. Oliver Stiemerling
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Version: 1.0
// Date:    09.10.2001
//
// History:
//

package org.freevolve.server;
import java.rmi.*;
import java.util.*;

/**
  Remote Interface, da nur von der Klasse RBD instanziiert wird.
   
  @see RBD
  */
public interface IR_RBD extends Remote {
  
  // Constants ***************************************************************;
  public final static String  PORTTRENNER = "-";
  public final static String  BINDKEY     = "rbind";


  public IR_DistComponent getOwner   () throws RemoteException;
  public IR_DistComponent getDistComponentOne() throws RemoteException;
  public IR_DistComponent getDistComponentTwo() throws RemoteException;
  public String           getName    () throws RemoteException;
  // Erzeugt aus dem RBD-Objekt einen String (Aufruf von RBind.write());
  public String           write      () throws RemoteException;
  // HIER IST DIE REIHENFOLGE WICHTIG! da c1 Besitzer ist !;
  public boolean          links      (IR_DistComponent c1, IR_DistComponent c2) throws RemoteException;
  public boolean          isEmpty    () throws RemoteException;
  public boolean          links      (IR_DistComponent c) throws RemoteException;
  public boolean          owns       (IR_DistComponent c) throws RemoteException;
  public Vector           getRBinds  (IR_DistComponent c, String portName) throws RemoteException;
  public Vector           getRBinds  () throws RemoteException;
  public void             rbind(String p1, String p2)     throws RBD_Exception, RemoteException;
  public void             unbind(String p1, String p2)    throws RemoteException;
}











