// The "freEvolve System" is a platform supporting the reconfiguration of 
// component-based applications'
// Copyright (C) 1999  Ralph Hinken and Dr. Oliver Stiemerling
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Version: 1.0
// Date:    09.10.2001
//
// History:
//

package org.freevolve.server;
import java.rmi.*;
import java.util.*;
import java.net.*;
/**
  Remote Interface, da nur von der Klasse Server instanziiert wird.
   
  @see Server
  */
public interface IR_Server extends Remote {

  public String           getID              (String user, String ID) throws RemoteException ;
  public IR_File          giveMeFile         () throws RemoteException ;
  public IR_Prop          giveMeProp         () throws RemoteException ;
  public String           getDCATName        (String user, String Anwendungsname) throws RemoteException ;

  public IR_Component     getNewComponent(String Typ) throws RemoteException ;
  public IR_DistComponent getNewApplication(String user, String ID, String Anwendungsname) throws RemoteException ;
  public void             removeApplication(String user, String ID, String Anwendungsname) throws RemoteException ;

  public IR_DistComponent getNewDistComp     (String user, String ID, String DCATname) throws RemoteException ;
  // findet nur erstes Vorkommen!;
  public IR_DistComponent getDistComponent   (String user, String ID, String compName) throws RemoteException;
  public void             removeDistComponent(String user, String ID, String compName) throws RemoteException;
  public Vector           getAllDistComps    () throws RemoteException ;
  public String           getFile            (String fileName) throws RemoteException;
  public void             message            (String  type, int importance, String text)  throws RemoteException;
  public void goodByeServer(String name, String ID) throws RemoteException;
  public void reset()  throws RemoteException;
  public String getServerInfo() throws RemoteException;

  
  public boolean saveComponent(IR_Component c,     String directory) throws RemoteException;
  public boolean saveDCAT     (IR_DistComponent c, String directory) throws RemoteException;
  public boolean saveRBD      (IR_RBD rbd,         String directory) throws RemoteException;
  public boolean saveDistComponent(IR_DistComponent c, String directory) throws RemoteException;

  public boolean addUser        (String name) throws RemoteException;
  public boolean removeUser     (String name) throws RemoteException;
  public boolean addUserGroup   (String name) throws RemoteException;
  public boolean removeUserGroup(String name) throws RemoteException;

  public boolean addToGroupForComp     (String userName, String groupName) throws RemoteException;
  public boolean addToGroupForAppl     (String userName, String groupName) throws RemoteException;
  public boolean removeFromGroupForComp(String userName, String groupName) throws RemoteException;
  public boolean removeFromGroupForAppl(String userName, String groupName) throws RemoteException;
  public Vector  whichGroupsForComp    (String userName) throws RemoteException;
  public Vector  whichGroupsForAppl    (String userName) throws RemoteException;

  public boolean   addApplication   (String user_or_group, String applName, String applType) throws RemoteException;
  public boolean   removeApplication(String user_or_group, String applType) throws RemoteException;
  public Hashtable getApplications  (String user_or_group) throws RemoteException;
  public Vector    getUsersOfAppl    (String aplType) throws RemoteException;
  public Vector    getGroupsOfAppl   (String aplType) throws RemoteException;
  public boolean   changeApplication(String user_or_group, String applTyp, String newApplType) throws RemoteException;

  public boolean   addComponent   (String user_or_group, String componentName, String componentTyp) throws RemoteException;
  public boolean   removeComponent(String user_or_group, String componentTyp) throws RemoteException;
  public Hashtable getComponents  (String user_or_group) throws RemoteException;
  public Vector    getUsersOfComp (String componentTyp) throws RemoteException;
  public Vector    getGroupsOfComp(String componentTyp) throws RemoteException;
  public boolean   changeComponent(String user_or_group, String compTyp, String newCompType) throws RemoteException;

  public void      changeScope(String oldDCATName, String newDCATName, String newCATName, Vector users) throws RemoteException;
//  public void addToEvolveServerURL(String ClassPath) throws RemoteException;
} 
