// The "freEvolve System" is a platform supporting the reconfiguration of 
// component-based applications'
// Copyright (C) 1999  Ralph Hinken and Dr. Oliver Stiemerling
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Version: 1.0
// Date:    09.10.2001
//
// History:
//

package org.freevolve.server;

import java.util.*;
import java.io.*;
import java.rmi.server.*;
import java.rmi.*;
import java.awt.*;
import java.lang.reflect.*;
import java.net.*;

public class Proxy  extends UnicastRemoteObject implements IR_Proxy {

  private String       type;            // unique for all components in appl.
  private String       name;                // same as typeName since only one instance per type is allowed ...
  private IR_Component comp;

          Hashtable    ports;               // Vector of PortProxy
          Hashtable    params;              // Vector of ParamProxy

          Hashtable    subProxies;       // key is Name (String)
                                         // value  is of type IR_Component !!!!! *********************
  private  Class  klasse;
  private  Object exemplar;
  private  Point   origin;
  private  Point   groesse;
  private  boolean isVisible;
  private  boolean isFlexiBean;                   
  private  boolean am_i_visible ;
  private Proxy    predecessor;
          I_Info   client;
  private Container  panel;
  public static URLClassLoader ucl = null;
  //public  URLClassLoader ucl = null;


  /** Baut den Proxy und verdrahted lokal.
  */
  public Proxy(IR_Component c, I_Info client, boolean visibility  )  throws RemoteException, Exception {
      super();
      am_i_visible = visibility;
      Enumeration e = null;
      PortProxy pport = null;
      PortProxy pport2 = null;
      ParamProxy pparam = null;
      IR_Component  csub = null;
      Proxy psub = null;
      Proxy psub2 = null;
      String c1 = null;
      String c2 = null;
      String p1 = null;
      String p2 = null;
      String cDef = null;
      ArrayList po = new ArrayList(5);
      ArrayList pa = new ArrayList(10);
      ArrayList sc = new ArrayList(64);
      ArrayList bpo = new ArrayList(64);
      ArrayList bpa = new ArrayList(64);

      StringTokenizer token = new StringTokenizer(c.getProxyDef(), ";");
      while (token.hasMoreTokens()) {
        String st = token.nextToken().trim();
        while (st.startsWith("component")) {
            cDef = st.substring(10);
            st = token.nextToken().trim();
        } //else
        while (st.startsWith("po")) {
            po.add(st.substring(3));
            st = token.nextToken().trim();
        } //else 
        while (st.startsWith("pa")) {
            pa.add(st.substring(3));
            st = token.nextToken().trim();
        } //else 
        while (st.startsWith("s")) {
            sc.add(st.substring(2).trim());
            st = token.nextToken().trim();
        } //else 
        while (st.startsWith("bpo")) {
            bpo.add(st.substring(4));
            st = token.nextToken().trim();
        } //else 
        while (st.startsWith("bpa")) {
            po.add(st.substring(4));
            st = token.nextToken().trim();
        } 
     }
      token = new StringTokenizer(cDef);

      this.type = token.nextToken();
      this.name = token.nextToken();
      this.comp = c;
      if (token.nextToken().equals("A")) this.isFlexiBean = true;
      else       this.isFlexiBean = false;
      //System.out.println(type + " " + name + " " + isFlexiBean);
      this.ports      = new Hashtable();
      this.params     = new Hashtable();
      this.subProxies = new Hashtable();
      this.client     = client;
      this.predecessor = null;
      this.panel       = client.getPanel();

      if (ucl == null) {
         ucl = client.getURLClassLoader();
      }
      client.message("proxy",5,"Proxy: Habe nun " + type);
      if (isFlexiBean) {
         if (ucl != null) klasse    = Class.forName(this.type, true, ucl);
         else             klasse    = Class.forName(this.type);

         if (this.type.equals("Lists.SharedList")) {
            client.message("proxy",5,"Habe jetzt Lists.SharedList");
            Constructor co[] = new Constructor[1];
            co = klasse.getConstructors();
            Object o[] = new Object[1];
            o[0] = (Object) new String("todo");
            exemplar = co[0].newInstance(o);

         } else {
            exemplar  = klasse.newInstance();
         }
         isVisible = checkVisibility(klasse);
      }
      for (Iterator i = po.iterator(); i.hasNext() ; ) {
        token = new StringTokenizer((String) i.next());
        String p = token.nextToken();
        String n = token.nextToken();
        String t = token.nextToken();
        pport = new PortProxy(n, t, p, this);
        ports.put(n, pport);
        if (isFlexiBean) {
            pport.readFunctions(klasse);
        }
      }

      for (Iterator i = pa.iterator(); i.hasNext() ; ) {      
          token = new StringTokenizer((String) i.next());      
          String n = token.nextToken();
          String t = token.nextToken();
          pparam = new ParamProxy(n, t, this);
          params.put(n, pparam);
          String v = token.nextToken();
          Object value = null;
          if (v.equals("V")) {
             String wert = "";
             while (token.hasMoreTokens()) {
               wert += token.nextToken() + " ";
             }
             value = getValue(wert.trim(), t);
          } 

          if (isFlexiBean) {
              pparam.readFunctions(klasse);
          }
          if (value != null) {
              setParam(n, value);
          }
      }
      
      if (!isFlexiBean) {
         klasse    = null;
         exemplar  = null;
         isVisible = false;
         for (Iterator i = sc.iterator(); i.hasNext() ; ) {      
            csub = (IR_Component) comp.getSubComponent((String) i.next());
            psub = new Proxy(csub, client, getVisibility());
            psub.predecessor = this;
            subProxies.put(psub.getName(), psub);
         }

         for (Iterator i = bpa.iterator(); i.hasNext() ; ) {      
            token = new StringTokenizer((String) i.next());      
            p1 = token.nextToken();
            c2 = token.nextToken();
            p2 = token.nextToken();          
            bindParams(p1, c2, p2);
         } // for all ParamBindings 
        
         for (Iterator i = bpo.iterator(); i.hasNext() ; ) {      
            token = new StringTokenizer((String) i.next());      
            c1 = token.nextToken();
            p1 = token.nextToken();
            c2 = token.nextToken();
            p2 = token.nextToken();          
            if (c1.equals("null")) c1 = ".";
            else if (c2.equals("null")) c2 = ".";
            bindPorts(c1, p1, c2, p2);
        } // for all PortBindings 

      }// if not Bean
      this.comp.addIR_Proxy(client.getUser(), client.getID(), this);
      if (isVisible && getVisibility() && panel!=null) {
         //((java.awt.Component) exemplar).setBounds(x,y,w,h);
         panel.add((java.awt.Component) exemplar);
     }

      client.message("proxy",1,"Proxy: Habe erzeugt "+type);
  } ///:~


  /** Verbinde die Ports c1.p1 mit c2.p2<br>
      Wenn eine Komponente c1 oder c2 gleich der lokalen ist, ist cX="."<br>
      Eine Verbindung wird zwischen den Ports eingetragen. Wenn ber diese
      Verbindung ber einen beliebigen Weg zwei Ports von FlexiBeans erreicht werden,
      werden diese "real" verbunden.

      @param c1 Der lokale Name der Komponente von Port1
      @param p1 Der Portname - in c1 angemeldet.
      @param c2 Der lokale Name der Komponente von Port2
      @param p2 Der Portname - in c2 angemeldet.
      @return true, falls die Anbindung erfolgreich war.
      @see #bindAll
  */
  public boolean bindPorts(String c1, String p1, String c2, String p2) {
  try {
      client.message("proxy",4,"Verbinde: "+c1+"."+p1+ " mit "+c2+"."+p2);
     Proxy psub = null;
     Proxy psub2 = null;
     IR_PortProxy pport = null;
     IR_PortProxy pport2 = null;
     IR_PortProxy phelp = null;
     boolean vertical = false;
     String temp;
     // Damit bei vertikalen Verbindungen c1 die "obere" Komponente ist.
     if (c2.equals(".")) {
         temp = c1; c1 = c2; c2=temp;
         temp = p1; p1 = p2; p2=temp;
     }
     if (c1.equals(".")) {
         psub = this ;  // vertikale Verbindung
         vertical = true;
     } else {
        psub = (Proxy) this.subProxies.get(c1);
        if (psub == null) {
           client.message("error", 1, "Proxy fr Subkomponente " + c1 + " existiert nicht.");
           return false;
        }
     }
     pport = (IR_PortProxy) psub.ports.get(p1);
     psub2  = (Proxy) this.subProxies.get(c2);
     if (psub2 == null) {
        client.message("error", 1, "Proxy fr Subkomponente " + c2 + " existiert nicht.");
        return false;
     }
     pport2 = (IR_PortProxy) psub2.ports.get(p2);
     if (pport == null) {
         client.message("error", 1, "Proxy fr Port " +name+"."+ p1 + " existiert nicht.");
         return false;
     }
     if (pport2 == null) {
         client.message("error", 1, "Proxy fr Port " +name+"."+ p2 + " existiert nicht.");
         return false;
     }
     // Proxies verbinden 
     Vector horPorts = null;
     Vector ports1 = new Vector();
     Vector ports2 = null;
     Enumeration e = null;
     if (vertical) {
         //client.message("proxy", 4, "Verbinde real ver: " + pport.toTxt() + "\nmit " + pport2.toTxt());
         // Hier wird die Verbindung bei den IR_PortProxy Objekten angemeldet:
         pport.addDown(pport2);  // pport  ist oben
         pport2.addUp(pport);    // pport2 ist unten
         // von pport nach oben horizontale Verbindungen sammeln
         horPorts = pport.getHorConnected();
         // von Horizontalen Verbindungen nach unten FlexiBeans-Ports sammeln
         for (e=horPorts.elements(); e.hasMoreElements() ; ) {
            phelp = (IR_PortProxy) e.nextElement();
            ports1.addAll(phelp.getLeafPorts());
         }
         // von pport2 nach unten FlexiBeans-Ports sammeln
         ports2 = pport2.getLeafPorts();
         /*
         for (Enumeration a=ports1.elements(); a.hasMoreElements(); ) {
            pport = (IR_PortProxy) a.nextElement();
            client.message("proxy",4,"P1V: " + pport.toTxt());
         }
         for (Enumeration a=ports2.elements(); a.hasMoreElements(); ) {
            pport = (IR_PortProxy) a.nextElement();
            client.message("proxy",4,"P2V: " + pport.toTxt());
         }
         */
         return bindAll(ports1, ports2);
         // verbinden
     } else {
         //client.message("proxy", 4, "Verbinde real hor: " + pport.toTxt() + "\nmit " + pport2.toTxt());
         pport.addHorizontal(pport2);
         pport2.addHorizontal(pport);
         // von beidden nach unten FlexiBeansPorts sammeln
         ports1 = pport.getLeafPorts();
         ports2 = pport2.getLeafPorts();
         /*
         for (Enumeration a=ports1.elements(); a.hasMoreElements(); ) {
            pport = (IR_PortProxy) a.nextElement();
            client.message("proxy",4,"P1H: " + pport.toTxt());
         }
         for (Enumeration a=ports2.elements(); a.hasMoreElements(); ) {
            pport = (IR_PortProxy) a.nextElement();
            client.message("proxy",4,"P2H: " + pport.toTxt());
         }
         */
         return bindAll(ports1, ports2);
     }
     } catch (Exception ex) {
         client.message("error",1,"**ERROR: Proxy.bindPorts: " +ex);
         return false;
      }
  }

/** Entbinde die Ports c1.p1 mit c2.p2<br>
      Wenn eine Komponente c1 oder c2 gleich der lokalen ist, ist cX="."<br>
      Eine (bestehende) Verbindung wird zwischen den Ports gelscht. Wenn ber die
      bisherige Verbindung ber einen beliebigen Weg zwei Ports von FlexiBeans erreicht werden,
      werden diese "real" entbunden.

      @param c1 Der lokale Name der Komponente von Port1
      @param p1 Der Portname - in c1 angemeldet.
      @param c2 Der lokale Name der Komponente von Port2
      @param p2 Der Portname - in c2 angemeldet.
      @return true, falls die Entbindung erfolgreich war.
      @see #unbindAll
  */
  public boolean unbindPorts(String c1, String p1, String c2, String p2) {
  try {
     client.message("proxy",4,"Entbinde: "+c1+"."+p1+ " mit "+c2+"."+p2);
     Proxy psub = null;
     Proxy psub2 = null;
     IR_PortProxy pport = null;
     IR_PortProxy pport2 = null;
     IR_PortProxy phelp = null;
     boolean vertical = false;
     String temp;
     // Damit bei vertikalen Verbindungen c1 die "obere" Komponente ist.
     if (c2.equals(".")) {
         temp = c1; c1 = c2; c2=temp;
         temp = p1; p1 = p2; p2=temp;
     }
     if (c1.equals(".")) {
         psub = this ;  // vertikale Verbindung
         vertical = true;
     } else {
        psub = (Proxy) this.subProxies.get(c1);
        if (psub == null) {
           client.message("error", 1, "Proxy fr Subkomponente " + c1 + " existiert nicht.");
           return false;
        }
     }
     pport = (IR_PortProxy) psub.ports.get(p1);
     psub2  = (Proxy) this.subProxies.get(c2);
     if (psub2 == null) {
        client.message("error", 1, "Proxy fr Subkomponente " + c2 + " existiert nicht.");
        return false;
     }
     pport2 = (IR_PortProxy) psub2.ports.get(p2);
     if (pport == null) {
         client.message("error", 1, "Proxy fr Port " +name+"."+ p1 + " existiert nicht.");
         return false;
     }
     if (pport2 == null) {
         client.message("error", 1, "Proxy fr Port " +name+"."+ p2 + " existiert nicht.");
         return false;
     }
     // Proxies verbinden 
     Vector horPorts = null;
     Vector ports1 = new Vector();
     Vector ports2 = null;
     Enumeration e = null;
     if (vertical) {
         //client.message("proxy", 4, "Entbinde real ver: " + pport.toTxt() + "\nmit " + pport2.toTxt());
         // Hier wird die Verbindung bei den IR_PortProxy Objekten abgemeldet:
         if (pport.removeDown(pport2) == false) {  // pport  ist oben
             client.message("error", 1, "**ERROR: Verbindung  " + pport.toTxt() + " mit " + pport2.toTxt() +" existiert nicht.");
             return false;
         }
         if (pport2.removeUp(pport) == false) {  // pport2  ist unten
             client.message("error", 1, "**ERROR: Verbindung  " + pport.toTxt() + " mit " + pport2.toTxt() +" existiert nicht.");
             return false;
         }
         // von pport nach oben horizontale Verbindungen sammeln
         horPorts = pport.getHorConnected();
         // von Horizontalen Verbindungen nach unten FlexiBeans-Ports sammeln
         for (e=ports1.elements(); e.hasMoreElements() ; ) {
            phelp = (IR_PortProxy) e.nextElement();
            ports1.addAll(phelp.getLeafPorts());
         }
         // von pport2 nach unten FlexiBeans-Ports sammeln
         ports2 = pport2.getLeafPorts();
         /*
         for (Enumeration a=ports1.elements(); a.hasMoreElements(); ) {
            pport = (IR_PortProxy) a.nextElement();
            client.message("proxy",4,"REMOVE P1V: " + pport.toTxt());
         }
         for (Enumeration a=ports2.elements(); a.hasMoreElements(); ) {
            pport = (IR_PortProxy) a.nextElement();
            client.message("proxy",4,"REMOVE P2V: " + pport.toTxt());
         }
         */
         return unbindAll(ports1, ports2);
         // verbinden
     } else {
         //client.message("proxy", 4, "ENTbinde real hor: " + pport.toTxt() + "\nmit " + pport2.toTxt());
         if (pport.removeHorizontal(pport2) == false) { 
             client.message("error", 1, "**ERROR: Verbindung  " + pport.toTxt() + " mit " + pport2.toTxt() +" existiert nicht.");
             return false;
         }
         if (pport2.removeHorizontal(pport) == false) {  
             client.message("error", 1, "**ERROR: Verbindung  " + pport.toTxt() + " mit " + pport2.toTxt() +" existiert nicht.");
             return false;
         }
         // von beidden nach unten FlexiBeansPorts sammeln
         ports1 = pport.getLeafPorts();
         ports2 = pport2.getLeafPorts();
         /*
         for (Enumeration a=ports1.elements(); a.hasMoreElements(); ) {
            pport = (IR_PortProxy) a.nextElement();
            client.message("proxy",4,"REMOVE P1H: " + pport.toTxt());
         }
         for (Enumeration a=ports2.elements(); a.hasMoreElements(); ) {
            pport = (IR_PortProxy) a.nextElement();
            client.message("proxy",4,"REMOVE P2H: " + pport.toTxt());
         }
         */
         return unbindAll(ports1, ports2);
     }
     } catch (Exception ex) {
         client.message("error",1,"**ERROR: Proxy.unbindPorts: " +ex);
         return false;
     }
  } // Ende unbindPorts

  /** Der lokale Name der Komponente
  */
  public String       getName() { return name; }

  /** Der Typ der Komponente.
  */
  public String       getType() { return type; }
  public void         setName(String n) { name = n;}
  public void         setType(String t) { type = t;}

  /** Der Proxy der Vaterkomponente.
  */
  public Proxy        getPredecessor() { return predecessor; }

  /** Das Component Objekt, dass dieses Proxy Objekt beschreibt.
  */
  public IR_Component getComponent() {return comp; }

  /** Das Objekt der FelxiBean.
  */
  public Object       getObject() { return exemplar; }

  /** Sind wir ein Proxy Objekt einer FlexiBean und sichtbar ?
  */
  public boolean isVisible() { return isVisible; }

  /** Sind wir ein Proxy Objekt einer FlexiBean ?
  */
  public boolean isFlexiBean() {return isFlexiBean; }

  /** Alle Proxy Objekte von FlexiBeans in unserer komplexen Komponente.
  */
  public static LinkedList  getBeanProxies(Proxy p) {
      LinkedList list    = new LinkedList();
      Proxy subProxy     = null;
      if (p.isFlexiBean()) list.add(p);
      else {
         for (Enumeration e = p.subProxies.elements(); e.hasMoreElements(); ) {
            subProxy = (Proxy) e.nextElement();
            list.addAll(getBeanProxies(subProxy));
         }
      }
      return list;
  }

  /** Zeigt alle Proxy Objekte von FlexiBeans in unserer komplexen Komponente auf
      dem Panel des Client an.
  */
  public void show() {
      Proxy p          = null;
      setVisibility(true);
      if (panel!=null && isVisible && getVisibility())  panel.remove((java.awt.Component) exemplar);
      for (Enumeration e = subProxies.elements(); e.hasMoreElements(); ) {
            p = (Proxy) e.nextElement();
            p.setVisibility(true);
            if (panel!=null && p.isVisible && p.getVisibility())  panel.add((java.awt.Component) p.exemplar);
      }
  }

  /** Entfernt alle Proxy Objekte von FlexiBeans in unserer komplexen Komponente von
      dem Panel des Client an.
  */
  public void hide() {
      Proxy p          = null;
      if (panel!=null && isVisible && getVisibility())  panel.remove((java.awt.Component) exemplar);
      setVisibility(false);

      for (Enumeration e = subProxies.elements(); e.hasMoreElements(); ) {
            p = (Proxy) e.nextElement();
            if (panel!=null && p.isVisible && p.getVisibility())  panel.remove((java.awt.Component) p.exemplar);
            p.setVisibility(false);
      }
  }
  

 /** Ist (X-Pos,Y-Pos) relativ zur Position der Vaterposition? Dann kriegen wir hiermit die absolute Position.
 */
  public java.awt.Point getAbsOrigin() {
      java.awt.Point p = origin;
      Proxy pre = getPredecessor();
      if (pre != null) {
         java.awt.Point p2 = pre.getAbsOrigin();
         p.translate(p2.x, p2.y);
      }
      return p;
  }

 /** Untersuche Klasse auf sichtbarkeit. Ist die Klasse von java.awt.Component abgeleitet?
 */
 private boolean checkVisibility(Class c) {
      java.awt.Component comp = (java.awt.Component) new java.awt.Label();
      //message("proxy", 4, "Class = " + c.getName());
      if (c==null) return false;
      if (c.isInstance(comp)) return true;
      Class superclass = c.getSuperclass();
      while (superclass != null) {
         //message("proxy", 4, "Class = " + superclass.getName());
         if (superclass.getName().equals("java.lang.Object")) return false;
         if (superclass.isInstance(comp)) return true;
         superclass = superclass.getSuperclass();
      }
      return false;
   }
 

/** Verbindet alle Ports aus ports1 mit allen aus ports2.
    Dazu mssen alle Ports von selben Typ sein, alle in ports1 dieselbe Polaritt haben 
    und alle in ports2 die entgegengesetzte Polaritt.<br>
    In ports1 und ports2 sind nur Ports von FlexiBean Proxy Objekten enthalten!
*/
public boolean bindAll(Vector ports1, Vector ports2) {
try {
    Enumeration e1      = ports1.elements();
    Enumeration e2      = ports2.elements();
    Vector help         = null;
    boolean     isEvent = false;
    Object      o       = null;

    if (!e1.hasMoreElements()) return true;
    if (!e2.hasMoreElements()) return true;
    IR_PortProxy pport1    = (IR_PortProxy) e1.nextElement();
    IR_PortProxy pport2    = null;
    //client.message("proxy",4,"Bind All geht weiter");
    if (pport1.getPolarity().equals("required")) {
        help = ports1;
        ports1 = ports2;
        ports2 = help;
        e1=ports1.elements();
        e2=ports2.elements();
    }

        IR_PortProxy pport     ;
        for (Enumeration a=ports1.elements(); a.hasMoreElements(); ) {
            pport = (IR_PortProxy) a.nextElement();
            //client.message("proxy",4,"P1: " + pport.toTxt());
         }
         for (Enumeration a=ports2.elements(); a.hasMoreElements(); ) {
            pport = (IR_PortProxy) a.nextElement();
            //client.message("proxy",4,"P2: " + pport.toTxt());
         }

    
    // Nun sind die Ports in e1 Provider !!!
    isEvent = pport1.isEvent();
    // Nun wissen wir alles...
    if (isEvent) {
        for (e1 = ports1.elements() ; e1.hasMoreElements() ; ) {
            pport1 = (IR_PortProxy) e1.nextElement();  // Provider: Eventsource
            // add    = pport1.getAddMethod();         // addEventListener
            for (e2 = ports2.elements() ; e2.hasMoreElements() ; ) {
                pport2 = (IR_PortProxy) e2.nextElement(); // Consumer: EventListener
                client.message("proxy", 4, "Verbinde (Event): " + pport1.toTxt() + "\nmit" + pport2.toTxt());
                try {
                    o = pport2.invokeGet();
                    //client.message("proxy",4,"habe object");
                    pport1.invokeAdd(o);
                    //client.message("proxy",4,"habe verbunden");
                } catch (Exception x) {
                    client.message("error",1, "**Proxy.bindAll: Event: " + x.toString());
                }
                
            }
        }
     } else {
        for (e1 = ports1.elements() ; e1.hasMoreElements() ; ) {
            pport1 = (IR_PortProxy) e1.nextElement();  // Provider: SharedObject owner
            for (e2 = ports2.elements() ; e2.hasMoreElements() ; ) {
                pport2 = (IR_PortProxy) e2.nextElement(); // Consumer: SharedObject user2
                client.message("proxy", 4, "Verbinde (Shared Objects): " + pport2.toTxt() + "\nmit" + pport1.toTxt());
                try {
                    o = pport1.invokeGet();
                    //client.message("proxy",4,"habe object");
                    pport2.invokeAdd(o);
                    //client.message("proxy",4,"habe verbunden");
                } catch (Exception x) {
                    client.message("error",1,"**Proxy.bindAll: SharedObject: " + x.toString());
                }
                
            }
        }
     } // end else (!isEvent)
     return true;
    } catch (Exception ex) {
         client.message("error",1,"**ERROR: Proxy.bindAll: " +ex);
         return false;
    }

  } // end bindAll

/** Entbindet alle Ports aus ports1 mit allen aus ports2.
    Dazu mssen alle Ports von selben Typ sein, alle in ports1 dieselbe Polaritt haben 
    und alle in ports2 die entgegengesetzte Polaritt.<br>
    In ports1 und ports2 sind nur Ports von FlexiBean Proxy Objekten enthalten!
*/
public boolean unbindAll(Vector ports1, Vector ports2) {
try {
    Enumeration e1      = ports1.elements();
    Enumeration e2      = ports2.elements();
    Vector help         = null;
    boolean     isEvent = false;
    Object      o       = null;

    if (!e1.hasMoreElements()) return true;
    if (!e2.hasMoreElements()) return true;
    IR_PortProxy pport1    = (IR_PortProxy) e1.nextElement();
    IR_PortProxy pport2    = null;
    //client.message("proxy",4,"Unbind All geht weiter");
    if (pport1.getPolarity().equals("required")) {
        help = ports1;
        ports1 = ports2;
        ports2 = help;
        e1=ports1.elements();
        e2=ports2.elements();
    }
        IR_PortProxy pport     ;
        /*
        for (Enumeration a=ports1.elements(); a.hasMoreElements(); ) {
            pport = (IR_PortProxy) a.nextElement();
            client.message("proxy",4,"REMOVE P1: " + pport.toTxt());
         }
         for (Enumeration a=ports2.elements(); a.hasMoreElements(); ) {
            pport = (IR_PortProxy) a.nextElement();
            client.message("proxy",4,"REMOVE P2: " + pport.toTxt());
         }
         */
    // Nun sind die Ports in e1 Provider !!!
    isEvent = pport1.isEvent();
    // Nun wissen wir alles...
    if (isEvent) {
        for (e1 = ports1.elements() ; e1.hasMoreElements() ; ) {
            pport1 = (IR_PortProxy) e1.nextElement();  // Provider: Eventsource
            for (e2 = ports2.elements() ; e2.hasMoreElements() ; ) {
                pport2 = (IR_PortProxy) e2.nextElement(); // Consumer: EventListener
                client.message("proxy", 4, "REMOVE Event: " + pport1.toTxt() + "\nvon" + pport2.toTxt());
                // Und, jetzt ....
                try {
                    o = pport2.invokeGet();
                    //client.message("proxy",4,"REMOVE habe object");
                    pport1.invokeRemove(o);
                    //client.message("proxy",4,"REMOVE habe entbunden");
                } catch (Exception x) {
                    client.message("error",1, "**Proxy.unbindAll: Event: " + x.toString());
                }
            } // alle aus e2
        } // alle aus e1
     } else {
        for (e1 = ports1.elements() ; e1.hasMoreElements() ; ) {
            pport1 = (IR_PortProxy) e1.nextElement();  // Provider: SharedObject owner
            for (e2 = ports2.elements() ; e2.hasMoreElements() ; ) {
                pport2 = (IR_PortProxy) e2.nextElement(); // Consumer: SharedObject user2
                client.message("proxy", 4, "REMOVE Shared Objects: " + pport2.toTxt() + "\nvon" + pport1.toTxt());
                // Und, jetzt ....
         
                try {
                    //o = pport1.invokeGet();
                    //client.message("proxy",4,"REMOVE habe object");
                    //reove.invoke(pport2.getOwner().getObject(), o);
                    pport2.invokeRemove(null);
                    //client.message("proxy",4,"habe entbunden");
                } catch (Exception x) {
                    client.message("error",1,"**Proxy.unbindAll: SharedObject: " + x.toString());
                }
                
            } // alle aus e2
        } // alle aus e1
     } // end else (!isEvent)
     return true;
     } catch (Exception ex) {
         client.message("error",1,"**ERROR: Proxy.unbindAll: " +ex);
         return false;
      }
  } // end unbindAll


  public IR_PortProxy getPort(String name) {
      return (IR_PortProxy) ports.get(name);
  }

   /** Verbinde die Parameter p1 mit c2.p2<br>
      Eine Verbindung wird zwischen den ParamProxy Objekten eingetragen. 
      Wenn ber diese
      Verbindung ein gesetzter Parameter einen Bean Parameter erreicht, wird der Wert
      zugewiesen. Dabei wird der Wert des ersten Parameter auf dem Weg nach 
      'oben' genommen.

      @param p1 Der Paramname
      @param c2 Der lokale Name der Komponente von Param2
      @param p2 Der Paramname - in c2 angemeldet.
      @return true, falls die Anbindung erfolgreich war.
      @see #bindAll
  */
  public boolean bindParams(String p1, String c2, String p2) {
     client.message("proxy",4,"Verbinde PARAM: "+p1+ " mit "+c2+"."+p2);
     Proxy psub2 = null;
     ParamProxy pparam = null;
     ParamProxy pparam2 = null;
     String temp;
     //client.message("proxy", 1, "bind PARM BETRETEN !!!");
     pparam = (ParamProxy) this.params.get(p1);
     psub2  = (Proxy) this.subProxies.get(c2);
     if (psub2 == null) {
        client.message("error", 1, "Proxy fr Subkomponente " + c2 + " existiert nicht.");
        return false;
     }
     pparam2 = (ParamProxy) psub2.params.get(p2);
     if (pparam == null) {
         client.message("error", 1, "Proxy fr param " +name+"."+ p1 + " existiert nicht.");
         return false;
     }
     if (pparam2 == null) {
         client.message("error", 1, "Proxy fr param " +name+"."+ p2 + " existiert nicht.");
         return false;
     }
     // Proxies verbinden 
     ParamProxy valueParam = null;
     Vector params2 = null;
     Enumeration e = null;
     //client.message("proxy", 4, "Verbinde PARAM real ver: " + pparam.toTxt() + "\nmit " + pparam2.toTxt());
     // Hier wird die Verbindung bei den ParamProxy Objekten angemeldet:
     pparam.addDown(pparam2);  // pparam  ist oben
     pparam2.addUp(pparam);    // pparam2 ist unten
     // von pparam nach oben einen Parameter mit Wert suchen
     valueParam = pparam.getValueParam();
     // kein Parameter mit Wert gefunden:
     if (valueParam == null) return true;
     // von pparam2 nach unten FlexiBeans-params sammeln
     params2 = pparam2.getLeafParams();

     return setParamAll(valueParam, params2);
     // verbinden
  }

     /** Lse die Verbindung von Parameter p1 mit c2.p2<br>

      @param p1 Der Paramname
      @param c2 Der lokale Name der Komponente von Param2
      @param p2 Der Paramname - in c2 angemeldet.
      @return true, falls die Entbindung erfolgreich war.
  */
  public boolean unbindParams(String p1, String c2, String p2) {
     boolean success = true;
     //client.message("proxy",4,"ENTbinde PARAM: "+p1+ " mit "+c2+"."+p2);
     Proxy psub2 = null;
     ParamProxy pparam = null;
     ParamProxy pparam2 = null;
     String temp;
     //client.message("proxy", 1, "UNbind PARM BETRETEN !!!");
     pparam = (ParamProxy) this.params.get(p1);
     psub2  = (Proxy) this.subProxies.get(c2);
     if (psub2 == null) {
        client.message("error", 1, "Proxy fr Subkomponente " + c2 + " existiert nicht.");
        return false;
     }
     pparam2 = (ParamProxy) psub2.params.get(p2);
     if (pparam == null) {
         client.message("error", 1, "Proxy fr param " +name+"."+ p1 + " existiert nicht.");
         return false;
     }
     if (pparam2 == null) {
         client.message("error", 1, "Proxy fr param " +name+"."+ p2 + " existiert nicht.");
         return false;
     }
     // Proxies entbinden 
     ParamProxy valueParam = null;
     Vector params2 = null;
     Enumeration e = null;
     //client.message("proxy", 4, "ENTbinde PARAM real ver: " + pparam.toTxt() + "\nmit " + pparam2.toTxt());
     // Hier wird die Verbindung bei den ParamProxy Objekten angemeldet:
     if (!pparam.removeDown(pparam2)) success = false;  // pparam  ist oben
     if (!pparam2.removeUp(pparam)) success = false;    // pparam2 ist unten
     return success;
  }

  public boolean setParamAll(ParamProxy valueParam, Vector beanParams) {
    Enumeration e1      = beanParams.elements();
    Vector help         = null;
    Object      o[]       = null;
    Method      set     = null;
    ParamProxy pparam   = null;

    if (!e1.hasMoreElements()) return true;
    if (valueParam == null   ) return true;

    o = new Object[1];
    o[0] = valueParam.getValue();   
    for ( e1 = beanParams.elements() ; e1.hasMoreElements() ; ) {
        pparam = (ParamProxy) e1.nextElement();  
        set   = pparam.getSetMethod();         
        //client.message("proxy", 4, "Setze Param " + pparam.toTxt() + "\nangewandt auf " + 
        //o[0].toString());
        if (set!=null) {
            try {
               set.invoke(pparam.getOwner().getObject(), o);
               client.message("proxy",4,"habe gesetzt auf " + o[0]);               //client.message("proxy",4,"habe gesetzt auf " + o);
           } catch (Exception x) {
               client.message("error",1, "**Proxy.setParamAll: " + pparam.toTxt() +": " + x.toString());
           }
        }
    }
    return true;
  } // end setParamAll

  public void setParam(String ParamName, Object value) {
    ParamProxy pparam = (ParamProxy) params.get(ParamName);
    if (pparam == null) return;
    pparam.setValue(value);
    if (ParamName.equals("X-Pos") || ParamName.equals("Y-Pos") || ParamName.equals("Height") || ParamName.equals("Width")) {
         resize();
    }
    Vector params = pparam.getLeafParams();
    setParamAll(pparam, params);
  }

  public void resize() {
    ParamProxy pparam   = null;
    int x;
    int y;
    int h;
    int w;
        pparam = (ParamProxy) params.get("X-Pos");
        if (pparam==null) {return; }
        x = ((Double) pparam.getValue()).intValue();
        pparam = (ParamProxy) params.get("Y-Pos");
        if (pparam==null) {return; }
        y = ((Double) pparam.getValue()).intValue();
        pparam = (ParamProxy) params.get("Height");
        if (pparam==null) {return; }
        h = ((Double) pparam.getValue()).intValue();
        pparam = (ParamProxy) params.get("Width");
        if (pparam==null) {return; }
        w = ((Double) pparam.getValue()).intValue();
        if (isVisible &&  panel!=null) {
            //System.out.println(">"+x+" "+y+" "+w+" "+h);
            ((java.awt.Component) exemplar).setBounds(x,y,w,h);
        }

  }


  public void unsetParam(String ParamName) {
    ParamProxy pparam = (ParamProxy) params.get(ParamName);
    if (pparam == null) return;
    pparam.unsetValue();
  }

  public void      addSubProxy(IR_Component c)  {
    try {
      Proxy p = new Proxy(c, this.client, getVisibility());
      //System.out.println("addSubProxy : " + getVisibility());
      p.predecessor = this;
      subProxies.put(p.getName(), p);
    } catch (Exception x) {
      client.message("error",1, "**Proxy.AddSubProxy: " + x.toString());
    }
  }

  public void      addPortProxy(IR_Port port)      {
    try {
      PortProxy pport = new PortProxy(port, this);
      ports.put(port.getName(), pport);
      if (isFlexiBean) {
          pport.readFunctions(klasse);
          //client.message("proxy",4,"PORT: "+ pport.toTxt());
      }
    } catch (Exception x) {
      client.message("error",1, "**Proxy.addPortProxy: " + x.toString());
    }
  }

  public void      addParamProxy(IR_Param param)      {
    try {
      ParamProxy pparam = new ParamProxy(param, this);
      params.put(pparam.getName(), pparam);
      if (isFlexiBean) {
          pparam.readFunctions(klasse);
          //client.message("proxy",4,"param: "+ pparam.toTxt());
      }
    } catch (Exception x) {
      client.message("error",1, "**Proxy.addParamProxy: " + x.toString());
    }
  }

  /** Alle Verbindungen mssen vorher vom Component Objekt entfernt werden!
  */
  public void      removeSubProxy(String localName)  {
      Proxy p = (Proxy) subProxies.remove(localName);
      p.hide();
  }

  /** Alle Verbindungen mssen vorher vom Component Objekt entfernt werden!
  */
  public void      removePortProxy(String name)      {
    ports.remove(name);    
  }

  /** Alle Verbindungen mssen vorher vom Component Objekt entfernt werden!
  */
  public void      removeParamProxy(String name)     {
    params.remove(name);
  }

  public void   changeTypeName        (String newTypeName) {
      type = newTypeName;  
  }

  public void changePortName        (String oldName, String newName)  {
      PortProxy pp =  (PortProxy) ports.remove(oldName);
      pp.setName(newName);
      ports.put(newName, pp);
  }

  public void changeParamName       (String oldName, String newName)  {
      ParamProxy pp =  (ParamProxy) params.remove(oldName);
      pp.setName(newName);
      params.put(newName, pp);
  }

  public void changeSubComponentName(String oldName, String newName)   {
      Proxy pp =  (Proxy) subProxies.remove(oldName);
      pp.setName(newName);
      params.put(newName, pp);
  }

  public void kill() {
     Proxy p = null;
     try {
         for (Enumeration e = subProxies.elements(); e.hasMoreElements() ; ) {
            p = (Proxy) e.nextElement();
            p.kill();
         }
         //am_i_visible = false;
         this.comp.removeIR_Proxy(client.getUser(), client.getID());
     } catch (Exception ex) {
           client.message("error", 1, "**ERROR: kill: Proxy von "+name+":"+type+" : "
                          +ex.toString() );
     }
  }

  public Object getValue(String v, String type) {
    if (type.equalsIgnoreCase("string")) {
      return (Object) v;
    }
    if (type.equalsIgnoreCase("boolean")) {
          if (v.equalsIgnoreCase("true")) return (Object) new Boolean(true);
          else return (Object) new Boolean(false);
    }
    if (v.equalsIgnoreCase("null")) {
      return null;
    }
    if (type.equalsIgnoreCase("int") || type.equalsIgnoreCase("double") || type.equalsIgnoreCase("long")) {
         return (Object) new Double(v);
    }
    if (type.equalsIgnoreCase("char")) {
      return (Object) new Character(v.charAt(0)); 
    }
    return (Object) new String("error");
  }

  public void setVisibility(boolean vis) {am_i_visible = vis; }

  public boolean getVisibility() { return am_i_visible;}

} ///:~                    